<?php

namespace App\Exports;

use Maatwebsite\Excel\Concerns\FromArray;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithEvents;
use Illuminate\Support\Facades\Session;
use App\Models\VehicleTrakingReportModel;
use Maatwebsite\Excel\Events\AfterSheet;
use Illuminate\Support\Facades\DB;

class VehicleOverspeedExport implements FromArray,WithHeadings,ShouldAutoSize,WithEvents
{
    protected $data;
    protected $headings;
    protected $columnWidth = [];
    protected $rowHeight = [];
    protected $mergeCells = [];
    protected $font = [];
    protected $fontSize = [];
    protected $bold = [];
    protected $background = []; 
    protected $vertical = []; 
    protected $sheetName;
    protected $borders = [];

    /**
    * @return \Illuminate\Support\Collection
    */
    public function array(): array
    {
        $aData = array();
        $aData['vehicle_id'] = Session::has('vehicle_id') ? Session::get('vehicle_id') : "";
        $aData['start_date'] = Session::has('start_date') ? Session::get('start_date').' 00:00:00': date('d-m-Y', strtotime('-1 month'));
        $aData['end_date'] = Session::has('end_date') ? Session::get('end_date') .' 23:59:59' : date('d-m-Y 23:59:59');
        $aData['aOverspeed'] = VehicleTrakingReportModel::vehicle_overspeed($aData);
        $aData['excel'] = array();
        if($aData['aOverspeed']){
            foreach($aData['aOverspeed']as $key=>$val){
                $p = 0;
                $count = count($val['all_data']['speed']);
                foreach($val['all_data']["speed"]as $value){
                                      $aData['excel'][] = array(
                        'vehicle_number' =>$val['vehicle_number'],
                        'date' =>  $p <= $count ? date('d-m-Y', $val['all_data']["datetime"][$p]) : "",
                        'time' =>  $p <= $count ?  date('h:i:s', $val['all_data']["datetime"][$p]) : "",
                        "speed" => $value
                    );
                    $p++;
                }     
            }
            
        }else{
            $aData['excel'][] = array(
            );     
        }
        return $aData['excel'];
    }

    public function headings(): array
    {        
        $aData['vehicle_id'] = Session::has('vehicle_id') ? Session::get('vehicle_id') : "";
        $aData['start_date'] = Session::has('start_date') ? Session::get('start_date').' 00:00:00': date('d-m-Y', strtotime('-1 month'));
        $aData['end_date'] = Session::has('end_date') ? Session::get('end_date') .' 23:59:59' : date('d-m-Y 23:59:59');
        $result = DB::table('vehicle_master')
                ->where('id', $aData['vehicle_id'])
                ->get();
        $vehicle_number = " ";
        foreach($result as $val){
            $vehicle_number  = $val->vehicle_number ;
        }
      
        return [
                ['Report Name: Vehicle Over Speed Report.'],
                ['Vehicle Number :'.$vehicle_number.'' ],
                ['Start Date :'.date('d-m-Y',  strtotime($aData['start_date']))], 
                ['End Date :'.date('d-m-Y',  strtotime($aData['end_date']))],
                [],
                [ 
                    'Vehicle Number',
                    'Date ',
                    'Time ',
                    'Speed',
                ]
            ];
    }

      /**
     * @return string
     */
    public function registerEvents(): array
    {
        return [
            AfterSheet::class => function(AfterSheet $event) {
                $event->sheet->getDelegate()->getStyle('A1:Z1265')->getAlignment()->setHorizontal('left');
                $event->sheet->getDelegate()->getStyle('A1:Z1265')->getAlignment()->setVertical('center');

                $event->sheet->mergeCells('A1:D1');
                $event->sheet->mergeCells('A2:C2');
                $event->sheet->mergeCells('A3:C3');
                $event->sheet->mergeCells('A4:C4');
                $event->sheet->mergeCells('A5:Z5');

                $event->sheet->getDelegate()->getRowDimension('1')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('2')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('3')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('4')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('6')->setRowHeight(25);

                $event->sheet->getStyle('A1:Z6')->applyFromArray([
                    'font'=>[
                            'bold'=>true,
                    ]
                ]);
                
                $aData['vehicle_id'] = Session::has('vehicle_id') ? Session::get('vehicle_id') : "";
                $aData['start_date'] = Session::has('start_date') ? Session::get('start_date').' 00:00:00': date('d-m-Y', strtotime('-1 month'));
                $aData['end_date'] = Session::has('end_date') ? Session::get('end_date') .' 23:59:59' : date('d-m-Y 23:59:59');
                $aData['aOverspeed'] = VehicleTrakingReportModel::vehicle_overspeed($aData);
                $rowSpan = 6;
                $p = 7;
                foreach($aData['aOverspeed']as $key=>$val){
                    $rowSpan += count($val['all_data']['speed']);;
                    $event->sheet->mergeCells('A'.$p.':A'.$rowSpan);
                    $counter = 0;
                    $p =  $rowSpan+1;
                    
                }
            },
        ];
    } 
}

