<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\AllRoutesModel;
use App\Models\VehicleModel;
use App\Libraries\Mysecurity;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\DB;

class AllRoutesController extends Controller
{
    public function __construct()
    {   
        $module_link = request()->segments(0);
        if(isset($module_link[0])){
            $module_link = $module_link[0];
            $this->mysecurity = new Mysecurity();
            $this->module_id = $this->mysecurity->get_module_id_by_name($module_link);
            $this->middleware(function ($request, $next){
                $this->mysecurity->check_access(Session::get('logged_in')['id'],$this->module_id,1);
        
                return $next($request);
            });
        }
    }

    public function clear_search(Request $request){
        session::forget('Pakage_id');
        session::forget('ward_id');
        session::forget('vehicle_id');
        session::forget('date');
        return redirect()->route('all_routes.index');  
    }

    public function index(Request $request)
    {   
        ini_set("memory_limit", "512M");
        //dd('ssss');
        $this->mysecurity->check_access(Session::get('logged_in')['id'],$this->module_id,1);
        
        $aData = array();
		$aData['ward_id'] = 0;
		$aData['vehicle_id'] = 0;
		$aData['search'] = 0;	

        if($request->form_type=='search_form'){ 
           // dd($request);
            session::put(['Pakage_id'  => $request->Pakage_id]);
            session::put(['ward_id'      => $request->ward_id]);
            session::put(['vehicle_id'   => $request->vehicle_id]);
            session::put(['date'         => $request->date]);
        }
      
        $aData['Pakage_id'] = session::has('Pakage_id') ? session::get('Pakage_id') : 2;
        $aData['ward_id']     = session::has('ward_id') ? session::get('ward_id') : 0;
        $aData['vehicle_id']  = session::has('vehicle_id') ? session::get('vehicle_id') : 0;
        $aData['date']        = session::has('date') ? session::get('date') : date('d-m-Y',strtotime('now'));
        
        $date = 0;
		if($aData['date'] != date('d-m-Y',strtotime('now'))){
			$date = 1;
		}

        if(!empty($aData['Pakage_id']) || !empty($aData['ward_id']) || !empty($aData['vehicle_id']) || !empty($date)){
			$aData['search'] = 1;
		}

        $aData['aRoutes'] = AllRoutesModel::get_all_routes($aData['ward_id'],$aData['vehicle_id'],$aData['Pakage_id'],$aData['date']);
        //echo 'mem:'.memory_get_usage();die;
       // dd($aData['aRoutes']);
       // $aData['aRoutes'] = array(); 

        $aData['Pakages']    = VehicleModel::get_Pakages()->orderBy('Pakage_name', 'ASC')->get();
        $aData['wards']        = VehicleModel::get_wards()->orderBy('ward_no', 'ASC')->get();
    
       return view('all_routes.show_all_routes', $aData);
    }
  
}
