<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\AdminModel;
use App\Rules\MatchOldPassword;
use Illuminate\Support\Facades\Session;


class ProfileController extends Controller
{
    public function index(){
        $aData = array();
        $user= Session::get('logged_in');
        $aData['aUser'] = AdminModel::findOrFail($user['id']);
        return view('user_profile.user_profile', $aData);
    }

    public function user_profile(Request $request){
        $this->validate($request,[
            'firstname' => 'required',
            'lastname' => 'required',
            'email' => 'required|email'
        ]);

        $user = AdminModel::findOrFail($request->user_id);
        $user->firstname = $request->firstname;
        $user->lastname = $request->lastname;
        $user->email = $request->email;
        $user->gender = $request->gender;
        $user->save();
        return back()->with('success', 'Profile Updated Successfully');
    }

    public function change_password(Request $request){
        $request->validate([
            'current_password' => ['required', new MatchOldPassword],
            'password' => ['required'],
            'password_confirmation' => ['same:password'],
        ]);

        AdminModel::where('id',$request->user_id)->update(['password'=> md5($request->password)]);
        return back()->with('success', 'Password change Successfully');  
    }

    public function change_theme_mode(Request $request){
         AdminModel::where('id', $request->id)->update(['theme_mode'=> $request->theme_mode]);
    }
}
