<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Session;
use File;
use ZipArchive;

class CommonModel extends Model
{
    use HasFactory;
    public $timestamps = false;

    public static function get_all_data($aSearch){

       // $dir = base_path('public/daily_data/');
      
        $aReturn = array();
		$sSQL = 'SELECT drd.id,drd.current_day,drd.vehicle_number,drd.route_id,(SELECT vehicle_number FROM vehicle_master WHERE id = drd.vehicle_number) as vehicle_name
					FROM daily_route_details as drd LEFT JOIN route_master as rm ON rm.id = drd.route_id WHERE 
			        drd.current_day = '.$aSearch['date'].' ';

        if(Session::has('logged_in.superuser') && Session::get('logged_in.superuser') !=1){
            $session_div = Session::get('Pakages'); 
            if(!empty($session_div)){
                $str_div = implode(',',$session_div);
                $sSQL .= ' AND rm.Pakage_id IN ('.$str_div.')';
            }else {
                $sSQL .= ' AND 1=2';
            }
        }            
		//echo $sSQL; die;
        $rResult =  DB::select( DB::raw($sSQL));
        
        $routeResult =  DB::select( DB::raw($sSQL));
        $route_array = array();
		foreach($routeResult as $aRes){
			$route_array[] = $aRes->route_id; 
		}
        //print_r($route_array); die;

        //----------------- route polygon --------------------------
        $sSQL = 'SELECT rp.route_id,rp.latitude,rp.longitude FROM route_polygon rp WHERE 1=1';
        if(!empty($route_array)){
			$route_id1 = implode(',',$route_array);
			$sSQL .= ' AND rp.route_id IN ('.$route_id1.')';
		}
        //echo $sSQL; die;
        $resArray1 = DB::select( DB::raw($sSQL), array());
        $aRoutepolygon = array();
		foreach($resArray1 as $res){
            $res->latitude       = (double)$res->latitude;
            $res->longitude      = (double)$res->longitude;
			$aRoutepolygon[$res->route_id][] = (array)$res;
		}
        //echo '<pre>'; print_r($aRoutepolygon); die;

        //----------------- checkpoint query -------------------
        $sSQL = 'SELECT ca.vehicle_number,ca.expected_time,ca.actual_reach_time,ca.location,ca.latitude,ca.longitude,(SELECT route_name FROM route_master WHERE id = ca.route_id) as route_name FROM checkpoint_arrival ca WHERE ca.date = '.$aSearch['date'];

        if(Session::has('logged_in.superuser') && Session::get('logged_in.superuser') !=1){
            if(!empty($route_array)){
                $route_id1 = implode(',',$route_array);
                $sSQL .= ' AND ca.route_id IN ('.$route_id1.')';
            } 
        }

        //echo $sSQL; die;
		//$sSQL .= ' ORDER BY ca.date DESC ';
		$aCAResultaray = DB::select( DB::raw($sSQL), array());
		
		$aAllCheckpoints = array();
		foreach($aCAResultaray as $aCA){
            $aCA->vehicle_number = (int)$aCA->vehicle_number;
            $aCA->latitude       = (double)$aCA->latitude;
            $aCA->longitude      = (double)$aCA->longitude;
			$aAllCheckpoints[$aCA->vehicle_number][] = (array)$aCA;
		}
        //echo '<pre>'; print_r($aAllCheckpoints); die;

        //----------------- default route query -------------------
        $sSQL = 'SELECT rd.route_id,rd.latitude,rd.longitude FROM route_details rd WHERE 1=1';
        if(!empty($route_array)){
			$route_id = implode(',',$route_array);
			$sSQL .= ' AND rd.route_id IN ('.$route_id.')';
		}
        //echo $sSQL; die;
        $resArray = DB::select( DB::raw($sSQL), array());
        $aAllDefaultroute = array();
		foreach($resArray as $res){
            $res->latitude       = (double)$res->latitude;
            $res->longitude      = (double)$res->longitude;
			$aAllDefaultroute[$res->route_id][] = (array)$res;
		}
        //echo '<pre>'; print_r($aAllDefaultroute); die;
        //----------------------------------
        $user_id = Session::get('logged_in.id');
       // echo $user_id; die; 
        if(!empty($rResult)){

            $current_date = strtotime($aSearch['date']);
            //-------- to create folder search date in timestamp
            $date_folder = base_path('public/daily_data/').$user_id.'/'.$current_date.'/';
            if(!is_dir($date_folder)){
                mkdir($date_folder, 0777, true);
            }

            //------------------
           // $vehicle_name = '';
            $date = date('Ymd');
            foreach($rResult as $key=>$aRes){
                $vehicle_name = $aRes->vehicle_name;
                $vehicle_no   = $aRes->vehicle_number;
                $route_id     = $aRes->route_id;
                
                //---- to create vehicle wise folder
                $vehicle_wise_folder = $date_folder.$vehicle_name.'/';
                if(!is_dir($vehicle_wise_folder)){
                    mkdir($vehicle_wise_folder, 0777, true);
                }

                //---- previous vehicle_details folder path
                $vehicle_details_folder = base_path('public/vehicle_details/'.$date.'/'.$vehicle_no.'.json');
                //echo $vehicle_details_folder; die;
                //echo file_get_contents($vehicle_details_folder); die;
                
                //---- to copy and paste vehicle_details in new folder
                $new_vehicle_details = $vehicle_wise_folder.'vehicle_details.json';
                if(file_exists($vehicle_details_folder)){
                  copy( $vehicle_details_folder, $new_vehicle_details );
                }

                //---- previous vehicle_stopped folder path
                $vehicle_stopped_folder = base_path('public/vehicle_stopped/'.$date.'/'.$vehicle_no.'.json');

                //---- to copy and paste vehicle_stopped in new folder
                $new_vehicle_stopped = $vehicle_wise_folder.'vehicle_stopped.json';
                if(file_exists($vehicle_stopped_folder)){
                   copy( $vehicle_stopped_folder, $new_vehicle_stopped );
                }

                //----------------- checkpoint file creation ------------------
                if(isset($aAllCheckpoints[$vehicle_no])){
			       if($aAllCheckpoints[$vehicle_no] > 0){
                       $aCAResultaray = $aAllCheckpoints[$vehicle_no];
                       $checkpoint_encode_file = str_replace(array('[', ']'), '', htmlspecialchars(json_encode($aCAResultaray), ENT_NOQUOTES));
                       //echo $checkpoint_encode_file.'<br><br>';
                     
                        $fileName = 'checkpoints.json';
                        $filePath = $vehicle_wise_folder.$fileName;

                        if(file_put_contents($filePath, $checkpoint_encode_file) !== false){
                           // echo "File Created ";
                        }else{
                            //echo "Cannot File Create.";
                        }
                   }
                }

                //----------------- route polygon file creation ------------------
                if(isset($aRoutepolygon[$route_id])){
                    if($aRoutepolygon[$route_id] > 0){
                        $aCAResultaray1 = $aRoutepolygon[$route_id];
                        $polygon_encode_file = str_replace(array('[', ']'), '', htmlspecialchars(json_encode($aCAResultaray1), ENT_NOQUOTES));
                       // echo $polygon_encode_file.'<br><br>';
                      
                         $fileName2 = 'route_polygon.json';
                         $filePath2 = $vehicle_wise_folder.$fileName2;
 
                         if(file_put_contents($filePath2, $polygon_encode_file) !== false){
                            // echo "File Created ";
                         }else{
                            // echo "Cannot File Create.";
                         }
                    }
                 }

                //----------------- default route file creation ------------------
                if(isset($aAllDefaultroute[$aRes->route_id])){ 
                    if($aAllDefaultroute[$aRes->route_id] > 0){
                        $resArray = $aAllDefaultroute[$aRes->route_id];
                        $defaultRoute_encode_file = str_replace(array('[', ']'), '', htmlspecialchars(json_encode($resArray), ENT_NOQUOTES));
                        //echo $checkpoint_encode_file.'<br><br>';
                      
                         $fileName1 = 'default_route.json';
                         $filePath1 = $vehicle_wise_folder.$fileName1;
 
                         if(file_put_contents($filePath1, $defaultRoute_encode_file) !== false){
                            // echo "File Created ";
                         }else{
                             //echo "Cannot File Create.";
                         }
                    }
                }
                
               
            }//die;
                //----------- download zip---------------
                if(!empty($aSearch['date'])){

                   // $archive_name = "vehicle_route_map.zip"; // name of zip file
                    $archive_name = $date.'.zip'; // name of zip file
                    $archive_folder = public_path('daily_data/').$user_id.'/'.$current_date.'/'; // the folder which you archivate
                   
                    $zipname = $date.'/';
                    $zip = new ZipArchive;
                    if ($zip -> open($archive_name, ZipArchive::CREATE) === TRUE)
                    {
                        $dir = preg_replace('/[\/]{2,}/', '/', $archive_folder);
                        $zip -> addEmptyDir($zipname);
                        //echo '<pre>'; print_r($dirs);
                        CommonModel::addContent($zip, realpath($archive_folder),$zipname);
                        $zip -> close();
                        
                       //print_r($zip); die;
                        $new_download_folder = base_path('public/downloads/').$date.'.zip';
                        $upload_file = base_path('public/').$date.'.zip';
                       
                        if(copy($upload_file,$new_download_folder)) {
                            unlink($upload_file);
                        }

                        $url = config('custom.base_url').'downloads/'.$archive_name;
                        return $url;
                    }
                    else
                    {
                        echo 'Error, can\'t create a zip file!';
                    }
                   
                }
        }
            
    }

    private static function addContent(\ZipArchive $zip, string $path,string $zipname)
    {
        /** @var SplFileInfo[] $files */
        $iterator = new \RecursiveIteratorIterator(
            new \RecursiveDirectoryIterator(
                $path,
                \FilesystemIterator::FOLLOW_SYMLINKS
            ),
            \RecursiveIteratorIterator::SELF_FIRST
        );
    
        while ($iterator->valid()) {
            if (!$iterator->isDot()) {
                $filePath = $iterator->getPathName();
                $relativePath = $zipname.'/'.substr($filePath, strlen($path) + 1);
                // echo '<br>rel:'.$relativePath; die;
                // echo '<br>'.$filePath; die;
                if (!$iterator->isDir()) {
                    $zip->addFile($filePath, $relativePath);
                } else {
                    if ($relativePath !== false) {
                        $zip->addEmptyDir($relativePath);
                    }
                }
            }
            $iterator->next();
        }
    }

    public static function get_daily_weight_mngmt($aSearch){
        $return_data = array();
        
        if(!empty($aSearch['date'])){
			$current_day = date('Ymd',strtotime($aSearch['date']));
		}else{
			$current_day = date('Ymd',strtotime('now'));
		}

        $sVehicleIds = VehicleTrakingReportModel::get_valid_vehicles('','',$aSearch);
        //dd($sVehicleIds);
        $sSQL = 'SELECT 
				(select vehicle_number from vehicle_master where id=wm.vehicle_number) as vehicle_number ,
				wm.loaded_weight,
				wm.unloaded_weight,
				wm.net_weight,
				wm.timestamp,
				d.type,
				wm.id
			from weight_mngt wm  
			LEFT JOIN route_master rm ON rm.id = wm.route_id LEFT JOIN daily_route_details d ON d.vehicle_number = wm.vehicle_number AND d.current_day = wm.current_day
			WHERE wm.loaded_weight > 0 AND wm.current_day = '.$current_day.' AND wm.weight_status = 1';

        if(!empty($aSearch['Pakage_id'])){
            $sSQL .= ' AND rm.Pakage_id ='.$aSearch['Pakage_id'];        
        }
        if($aSearch['vehicle_id'] > 0){
            $sSQL .= ' AND wm.vehicle_number = '.$aSearch['vehicle_id'];
        }
        // if($aSearch['vehicle_type_id'] > 0){
        //     $sSQL .= ' AND d.type = '.$aSearch['vehicle_type_id'];
        // }
		if(!empty($sVehicleIds)){
			$sSQL .= ' AND wm.vehicle_number IN ('.$sVehicleIds.')';
		}else{
			$sSQL .= ' AND 1=2';
		}	
        if(Session::has('logged_in.superuser') && Session::get('logged_in.superuser') !=1){
            $session_div = Session::get('Pakages'); 
            if(!empty($session_div)){
                $str_div = implode(',',$session_div);
                $sSQL .= ' AND rm.Pakage_id IN ('.$str_div.')';
            }else {
                $sSQL .= ' AND 1=2';
            }
        }
    
        $sSQL .= ' ORDER BY wm.`timestamp` DESC';
        //echo $sSQL; die;
        $rResult =  DB::select( DB::raw($sSQL), array());

        foreach($rResult as $aRes){
            $return_data[] = $aRes;
        }
       // dd($return_data);
		return $return_data;
       
    }

   
}

?>