<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Session;
use App\Libraries\Mysecurity;
use App\Models\VehicleTrakingReportModel;

class HomeModel extends Model
{
    use HasFactory;
    protected $table = 'admin_modules';
    
    public static function get_total_vehicle(){
        $current_date = date('Ymd');
        $sSQL = 'SELECT SUM(dtv.no_of_vehicles) as total_vehicles FROM daily_total_vehicles dtv WHERE dtv.day ='.$current_date;

		if(Session::has('logged_in.superuser') && Session::get('logged_in.superuser') !=1){
			$session_div = Session::get('Pakages'); 
			if(!empty($session_div)){
				$str_div = implode(',',$session_div);
				$sSQL .= ' AND dtv.Pakage_id IN ('.$str_div.')';
			}else {
				$sSQL .= ' AND 1=2';
			}
		}
		// echo $sSQL; die;
		$rRes = DB::select( DB::raw($sSQL));
		$Result = collect($rRes)->first();
       // dd($Result);
		return (array)$Result;
    }

    public static function get_present_vehicle(){
        $current_date = date('Ymd');
        $sPSQL = 'SELECT current_day,count(drd.id) as present_vehicle 
					FROM daily_route_details drd  
					LEFT JOIN route_master rm ON drd.route_id = rm.id 
				WHERE drd.is_present = 1 AND drd.current_day ='.$current_date;

		if(Session::has('logged_in.superuser') && Session::get('logged_in.superuser') !=1){
			$session_div = Session::get('Pakages'); 
			if(!empty($session_div)){
				$str_div = implode(',',$session_div);
				$sPSQL .= ' AND rm.Pakage_id IN ('.$str_div.')';
			}else {
				$sPSQL .= ' AND 1=2';
			}
		}
        //echo $sPSQL; die;
        $rRes = DB::select( DB::raw($sPSQL));
		$Result = collect($rRes)->first();
		return (array)$Result;
    }

    public static function get_total_employee(){
        $current_date = date('Ymd');
        $small_vehicles = HomeModel::get_vehicles($current_date,'small');
		$big_vehicles   = HomeModel::get_vehicles($current_date,'big');
       //dd($big_vehicles);
        $total_employee = ($small_vehicles * 2) + ($big_vehicles * 3);
        //dd($total_employee);
        return $total_employee;
    }

    public static function get_vehicles($current_day,$type){
        $count = 0;
		$sVehSql = 'SELECT sum(no_of_vehicles) as count   
						FROM daily_total_vehicles dtv 
						WHERE dtv.day = '.$current_day.' ';
						
		if($type == 'small'){
			$sVehSql .= ' AND dtv.vehicle_type_id = 6';
		}elseif($type == 'big'){
			$sVehSql .= ' AND dtv.vehicle_type_id != 6';
		}else{
			$sVehSql .= ' AND 1=2';
		}
		
        if(Session::has('logged_in.superuser') && Session::get('logged_in.superuser') !=1){
			$session_div = Session::get('Pakages'); 
			if(!empty($session_div)){
				$str_div = implode(',',$session_div);
				$sVehSql .= ' AND dtv.Pakage_id IN ('.$str_div.')';
			}else {
				$sVehSql .= ' AND 1=2';
			}
		}
		//echo $sVehSql; die;
		$rVRes =  DB::select( DB::raw($sVehSql));
		if(!empty($rVRes)){
			$Result = collect($rVRes)->first();
			$count = $Result->count;
		}
		return $count;
    }

    public static function get_present_in_employee($type){
        $sDate = date('Y-m-d',strtotime('now'));
        $iCurrentDay = strtotime($sDate.'00:00:00');
        //echo $iCurrentDay; die;
        $count = 0;
		$presentSql = 'select count(ua.id) as presentCount from users_attendance ua where report_invalid=0 AND attendance_date = '.$iCurrentDay;
        
        if($type == 1){
            $presentSql .= ' AND ua.success=1'; 
        }

		if(Session::has('logged_in.superuser') && Session::get('logged_in.superuser') !=1){
			$session_div = Session::get('Pakages'); 
			if(!empty($session_div)){
				$str_div = implode(',',$session_div);
				$presentSql .= ' AND ua.Pakage_id IN ('.$str_div.')';
			}else{
				$presentSql .= ' AND 1=2';
			}
		}
		// echo $presentSql;die;
		$rVRes = DB::select( DB::raw($presentSql));
		if(!empty($rVRes)){
			$Result = collect($rVRes)->first();
			$count = $Result->presentCount;
		}
		return $count;
    }
	public static function get_daily_checkpoints_old(){
		$aResult = array();
		$current_date = date('Ymd');

		$sSQL = 'SELECT drd.id,drd.route_id,drd.vehicle_number,(SELECT vehicle_number FROM vehicle_master WHERE id = drd.vehicle_number) as vehicle_name,drd.default_points,drd.cover_points
					FROM daily_route_details drd  
					LEFT JOIN route_master rm ON drd.route_id = rm.id 
				WHERE drd.current_day ='.$current_date;
	    $sSQL .= ' AND (drd.type = 1 OR drd.type = 6)';
		
		if(Session::has('logged_in.superuser') && Session::get('logged_in.superuser') !=1){
			$session_div = Session::get('Pakages'); 
			if(!empty($session_div)){
				$str_div = implode(',',$session_div);
				$sSQL .= ' AND rm.Pakage_id IN ('.$str_div.')';
			}else {
				$sSQL .= ' AND 1=2';
			}
		}
		$rResult = DB::select( DB::raw($sSQL));
        
		$route_array = array();
		foreach($rResult as $aRes){
			$route_array[] = $aRes->route_id; 
		}
		//dd($route_array);
        //--------------- previous checkpoint ---------------------------------
		$preSQL = 'SELECT ca.route_id,ca.expected_time as pre_expected_time,ca.actual_reach_time,ca.location as previous_location FROM checkpoint_arrival as ca WHERE ca.date ='.$current_date;

		if(!empty($route_array)){
			$route_id = implode(',',$route_array);
			$preSQL .= ' AND ca.route_id IN ('.$route_id.')';
		}
        //$preSQL .=' group by ca.route_id';
		$preSQL .=' order by expected_time desc';
		//echo $preSQL; die;
		$aCAResultaray = DB::select( DB::raw($preSQL));
     
		$aAllCheckpoints = array();
		foreach($aCAResultaray as $aCA){
			$aAllCheckpoints[$aCA->route_id][] = $aCA;
		}
		//dd($aAllCheckpoints);
        
		//---------------------- Next checkpoint ----------------------------------------
		if(!empty($route_array)){
			$route_id = implode(',',$route_array);
		}else{
			$route_id = (0);
		}

		$nextSQL = 'select route_id,min(expected_time) as next_expected_time,location as next_location from route_checkpoints rc WHERE route_id IN ('.$route_id.') AND ( CASE WHEN (select count(id) FROM checkpoint_arrival where date = '.$current_date.' AND route_id=rc.route_id ) > 0 THEN expected_time > (select expected_time FROM checkpoint_arrival where date = '.$current_date.' AND route_id=rc.route_id order by expected_time desc limit 1 ) ELSE 1=1 END ) group by route_id';
        
		$Resultarray = DB::select( DB::raw($nextSQL));
		$nextCheckpoints = array();
		foreach($Resultarray as $res){
			  $nextCheckpoints[$res->route_id][] = $res;
		}
        
		$checkResult = DB::select( DB::raw($sSQL));
		$return_data = array();
		foreach($checkResult as $aRes){
           
			$return_data[$aRes->route_id]['vehicle_name'] = $aRes->vehicle_name;
			$return_data[$aRes->route_id]['percentage'] = !empty($aRes->default_points) ? ($aRes->cover_points/$aRes->default_points)*100 : '';
            
			//------------- previous checkpoint
			if(isset($aAllCheckpoints[$aRes->route_id]))
			    if($aAllCheckpoints[$aRes->route_id] > 0){

				   $return_data[$aRes->route_id]['pre_expected_time'] = $aAllCheckpoints[$aRes->route_id][0]->pre_expected_time;
				   $return_data[$aRes->route_id]['actual_reach_time'] = $aAllCheckpoints[$aRes->route_id][0]->actual_reach_time;
				   $return_data[$aRes->route_id]['previous_location'] = $aAllCheckpoints[$aRes->route_id][0]->previous_location;
			    }

            //------------- next checkpoint
			if(isset($nextCheckpoints[$aRes->route_id]))
			    if($nextCheckpoints[$aRes->route_id] > 0){

				   $return_data[$aRes->route_id]['next_expected_time'] = $nextCheckpoints[$aRes->route_id][0]->next_expected_time;
				   $return_data[$aRes->route_id]['next_location'] = $nextCheckpoints[$aRes->route_id][0]->next_location;
			    }

		}
	    // dd($return_data);
         return $return_data;
	}
	public static function get_daily_checkpoints(){
		$aResult = array();
		$current_date = date('Ymd');

		$sSQL = 'SELECT drd.id,drd.route_id,drd.vehicle_number,(SELECT vehicle_number FROM vehicle_master WHERE id = drd.vehicle_number) as vehicle_name,drd.default_points,drd.cover_points
					FROM daily_route_details drd  
					LEFT JOIN route_master rm ON drd.route_id = rm.id 
				WHERE drd.current_day ='.$current_date;
	    $sSQL .= ' AND (drd.type = 1 OR drd.type = 6)';
		
		if(Session::has('logged_in.superuser') && Session::get('logged_in.superuser') !=1){
			$session_div = Session::get('Pakages'); 
			if(!empty($session_div)){
				$str_div = implode(',',$session_div);
				$sSQL .= ' AND rm.Pakage_id IN ('.$str_div.')';
			}else {
				$sSQL .= ' AND 1=2';
			}
		}
		$checkResult = $rResult = DB::select( DB::raw($sSQL));
        
		$route_array = array();
		foreach($rResult as $aRes){
			$route_array[] = $aRes->route_id; 
		}
		//dd($route_array);
        //--------------- previous checkpoint ---------------------------------
		$preSQL = 'SELECT ca.route_id,ca.expected_time as pre_expected_time,ca.actual_reach_time,ca.location as previous_location FROM checkpoint_arrival as ca WHERE ca.date ='.$current_date;
		$route_id = (0);
		if(!empty($route_array)){
			$route_id = implode(',',$route_array);
			$preSQL .= ' AND ca.route_id IN ('.$route_id.')';
		}
		unset($route_array);
        //$preSQL .=' group by ca.route_id';
		$preSQL .=' order by expected_time desc';
		//echo $preSQL; die;
		$aCAResultaray = DB::select( DB::raw($preSQL));
     
		$aAllCheckpoints = array();
		foreach($aCAResultaray as $aCA){
			$aAllCheckpoints[$aCA->route_id][] = $aCA;
		}
		//dd($aAllCheckpoints);
        
		//---------------------- Next checkpoint ----------------------------------------
		
		$aLastCheckpoint = array();
		$last = 'select route_id,max(expected_time) as last_point,count(id) as total_achieved_checkpoints FROM checkpoint_arrival where date = '.$current_date.' group by route_id';
		$LastArray = DB::select( DB::raw($last));
		foreach($LastArray as $res){
			  $aLastCheckpoint[$res->route_id]['last_point'] = $res->last_point;
			  $aLastCheckpoint[$res->route_id]['total_achieved_checkpoints'] = $res->total_achieved_checkpoints;
		}

		$nextSQL = 'select route_id,expected_time as next_expected_time,location as next_location from route_checkpoints rc WHERE route_id IN ('.$route_id.') ORDER BY expected_time';

		//$nextSQL = 'select route_id,min(expected_time) as next_expected_time,location as next_location from route_checkpoints rc WHERE route_id IN ('.$route_id.') AND ( CASE WHEN (select count(id) FROM checkpoint_arrival where date = '.$current_date.' AND route_id=rc.route_id ) > 0 THEN expected_time > (select expected_time FROM checkpoint_arrival where date = '.$current_date.' AND route_id=rc.route_id order by expected_time desc limit 1 ) ELSE 1=1 END ) group by route_id';
        
		$Resultarray = DB::select( DB::raw($nextSQL));
		$nextCheckpoints = array();
		$firstCheckpoints = array();
		$RouteCheckpointCount = array();
		foreach($Resultarray as $res){

			  if(empty($firstCheckpoints[$res->route_id]))
			  	$firstCheckpoints[$res->route_id] = $res;	
			  if(isset($aLastCheckpoint[$res->route_id]) && $res->next_expected_time > $aLastCheckpoint[$res->route_id]['last_point'])	
			  		$nextCheckpoints[$res->route_id][] = $res;
			  if(isset($RouteCheckpointCount[$res->route_id]))
			  		$RouteCheckpointCount[$res->route_id] += 1;
			  else
			  	$RouteCheckpointCount[$res->route_id] = 1;
		}
        
		//$checkResult = DB::select( DB::raw($sSQL));
		$return_data = array();
		foreach($checkResult as $aRes){
			//echo  $RouteCheckpointCount[$aRes->route_id] ;
			//echo '<Br>'.$aLastCheckpoint[$aRes->route_id]['total_achieved_checkpoints'] ;
            if(empty($nextCheckpoints[$aRes->route_id]) && isset($firstCheckpoints[$aRes->route_id]) && ((isset($aLastCheckpoint[$aRes->route_id]['total_achieved_checkpoints']) && $RouteCheckpointCount[$aRes->route_id] < $aLastCheckpoint[$aRes->route_id]['total_achieved_checkpoints']) || !isset($aLastCheckpoint[$aRes->route_id]['total_achieved_checkpoints']))  )
				$nextCheckpoints[$aRes->route_id][] = $firstCheckpoints[$aRes->route_id];
			
			$return_data[$aRes->route_id]['vehicle_name'] = $aRes->vehicle_name;
			$return_data[$aRes->route_id]['percentage'] = !empty($aRes->default_points) ? ($aRes->cover_points/$aRes->default_points)*100 : '';
            
			//------------- previous checkpoint
			if(isset($aAllCheckpoints[$aRes->route_id]))
			    if($aAllCheckpoints[$aRes->route_id] > 0){

				   $return_data[$aRes->route_id]['pre_expected_time'] = $aAllCheckpoints[$aRes->route_id][0]->pre_expected_time;
				   $return_data[$aRes->route_id]['actual_reach_time'] = $aAllCheckpoints[$aRes->route_id][0]->actual_reach_time;
				   $return_data[$aRes->route_id]['previous_location'] = $aAllCheckpoints[$aRes->route_id][0]->previous_location;
			    }

            //------------- next checkpoint
			if(isset($nextCheckpoints[$aRes->route_id]))
			    if($nextCheckpoints[$aRes->route_id] > 0){

				   $return_data[$aRes->route_id]['next_expected_time'] = $nextCheckpoints[$aRes->route_id][0]->next_expected_time;
				   $return_data[$aRes->route_id]['next_location'] = $nextCheckpoints[$aRes->route_id][0]->next_location;
			    }

		}
		unset($nextCheckpoints);
		unset($firstCheckpoints);
		unset($RouteCheckpointCount);
	    // dd($return_data);
         return $return_data;
	}

	public static function get_total_garbage_collection(){
		$current_day = date('Ymd');
		// $sSQL = 'SELECT wgm.id,wgm.current_day,sum(net_weight) as total_weight FROM weight_mngt wgm left join vehicle_master vm on vm.id = wgm.vehicle_number where wgm.current_day = '.$current_day.' group by wgm.vehicle_number';

		$sVehicleIds = VehicleTrakingReportModel::get_valid_vehicles('','',$current_day);
		//dd($sVehicleIds);
		$sSQL = 'SELECT wm.id,wm.current_day,wm.route_id,
						SUM(loaded_weight) AS total_loaded,
						SUM(unloaded_weight) AS total_unloaded,
						SUM(net_weight) AS total_net,rm.Pakage_id,(select Pakage_name from admin_pakages where id = rm.Pakage_id) as Pakage_name
					FROM weight_mngt wm 
					LEFT JOIN route_master rm ON rm.id = wm.route_id LEFT JOIN daily_route_details d ON d.vehicle_number = wm.vehicle_number AND d.current_day = wm.current_day
		         	WHERE wm.loaded_weight > 0 AND wm.current_day = '.$current_day.' ';
		
		if(!empty($sVehicleIds)){
		    $sSQL .= ' AND wm.vehicle_number IN('.$sVehicleIds.')';
		}
		
		// echo $sSQL; die;

		if(Session::has('logged_in.superuser') && Session::get('logged_in.superuser') !=1){
			$session_div = Session::get('Pakages'); 
			if(!empty($session_div)){
				$str_div = implode(',',$session_div);
				$sSQL .= ' AND rm.Pakage_id IN ('.$str_div.')';
			}else {
				$sSQL .= ' AND 1=2';
			}
		}

		$sSQL .= ' GROUP BY rm.Pakage_id order by Pakage_name ASC';
		//echo $sSQL; die;
	    $rData = DB::select( DB::raw($sSQL));
	    $aReturn = array();
		$total_net = 0;
		$grand_total = 0;
	    foreach($rData as $aRes){
			$total_net = $aRes->total_net;
			$aReturn['total_div_weight'] = $grand_total += $total_net;
		}
		return $aReturn;
	}
   
	//----------------------- admin dashboard query ----------------
	public static function get_Pakagewise_Present_vehicle($aSearch){

		    $aReturn = array();
			$sSQL = 'SELECT dtv.*,SUM(no_of_vehicles) as total_vehicles,ad.Pakage_name		
				   FROM daily_total_vehicles dtv LEFT JOIN admin_pakages as ad ON ad.id= dtv.Pakage_id WHERE day = '.$aSearch['date'].'  
				   GROUP BY dtv.Pakage_id order by ad.Pakage_name ASC';
            //echo $sSQL; die;
		   $rData =  DB::select( DB::raw($sSQL));
		   $aReturn = array();
		   $aLables = array();
		   foreach($rData as $aRes){
			    $sPSQL = 'SELECT count(drd.id) as present 
						   FROM daily_route_details drd 
						   LEFT JOIN route_master rm ON drd.route_id = rm.id 
					   WHERE 
					   rm.Pakage_id = '.$aRes->Pakage_id.' AND 
					   drd.is_present = 1 AND 
					   drd.current_day = '.$aSearch['date'];
						   
			    $rResult = DB::select( DB::raw($sPSQL));
			    $present_vehicles = 0;
			    if(!empty($rResult)){
				   $apResult = collect($rResult)->first();
				   $present_vehicles = $apResult->present;
			    }
   
			    $aRes->present_vehicles = $present_vehicles;
			    $aReturn[] = (array)$aRes; 
		   }
   
		    //echo '<pre>';print_r($aReturn);die;
		   return $aReturn;
	}

	public static function get_Pakagewise_wieght_ton($aSearch){
        $aReturn = array();
		// $sSQL = 'SELECT wm.id,wm.current_day,wm.route_id,
		// 				SUM(loaded_weight) AS total_loaded,
		// 				SUM(unloaded_weight) AS total_unloaded,
		// 				SUM(net_weight) AS total_net,rm.Pakage_id,ad.Pakage_name
		// 			FROM weight_mngt wm 
		// 			LEFT JOIN route_master rm ON wm.route_id = rm.id 
		// 			LEFT JOIN admin_pakages ad ON ad.id= rm.Pakage_id 
		// 			WHERE wm.current_day = '.$aSearch['date'].' GROUP BY rm.Pakage_id order by ad.Pakage_name ASC';

		$sVehicleIds = VehicleTrakingReportModel::get_valid_vehicles('','',$aSearch);
	    //dd($sVehicleIds);
	    $sSQL = 'SELECT wm.id,wm.current_day,wm.route_id,
						SUM(loaded_weight) AS total_loaded,
						SUM(unloaded_weight) AS total_unloaded,
						SUM(net_weight) AS total_net,rm.Pakage_id,(select Pakage_name from admin_pakages where id = rm.Pakage_id) as Pakage_name
					FROM weight_mngt wm 
					LEFT JOIN route_master rm ON rm.id = wm.route_id LEFT JOIN daily_route_details d ON d.vehicle_number = wm.vehicle_number AND d.current_day = wm.current_day
		         	WHERE wm.loaded_weight > 0 AND wm.current_day = '.$aSearch['date'].' ';
        if(!empty($sVehicleIds)){
        	$sSQL .= 'AND wm.vehicle_number IN('.$sVehicleIds.') ';
        }
        
		$sSQL .= 'GROUP BY rm.Pakage_id order by Pakage_name ASC';
		//echo $sSQL; die;
		$rResult =  DB::select( DB::raw($sSQL));
		foreach($rResult as $aRes){
			if($aRes->Pakage_id > 0){
				$aRes->tons = $aRes->total_net/1000;
				$aReturn[] = (array)$aRes; 
			}
			
		}
		//dd($aReturn);
		return $aReturn;	
	}

	// public static function get_most_abset_vehicles($aSearch){
    //     $aReturn = array();
	// 	$sSQL = 'SELECT drd.vehicle_number,count(drd.id) as absent_count,(select vehicle_number from vehicle_master where id=drd.vehicle_number) as vehicle_number_str,(select Pakage_name from admin_pakages adv left join vehicle_master vm on adv.id=vm.Pakage_id where vm.id = drd.vehicle_number) as Pakage_name FROM `daily_route_details` drd WHERE current_day > '.$aSearch['start_date'].' and current_day < '.$aSearch['end_date'].' and `is_present` = 1 group by vehicle_number having absent_count > 0 order by absent_count desc limit 25';
	// 	//echo $sSQL; die;
	// 	$rData = DB::select( DB::raw($sSQL));
	//     foreach($rData as $aRes){
	// 		$aReturn[] = (array)$aRes; 
	// 	}
	// 	//dd($aReturn);
	// 	return $aReturn;
	// }

	// public static function getLessWeightCarryingVehicles($aSearch){
	// 	$sSQL = 'SELECT wgm.id,wgm.current_day,sum(net_weight) as total_weight,(select vehicle_number from vehicle_master where id = wgm.vehicle_number) as vehicle_number_str,(select Pakage_name from admin_pakages adv left join vehicle_master vm on adv.id=vm.Pakage_id where vm.id=wgm.vehicle_number) as Pakage_name FROM weight_mngt wgm WHERE wgm.current_day BETWEEN '.$aSearch['start_date'].' AND '.$aSearch['end_date'].' group by wgm.vehicle_number order by total_weight limit 25';	
	// 	//echo $sSQL; die;
	//     $rData = DB::select( DB::raw($sSQL));
	//     $aReturn = array();
	//     foreach($rData as $aRes){
	// 		$aReturn[] = (array)$aRes; 
	// 	}
	// 	//echo '<pre>'; print_r($aReturn); die;
	// 	return $aReturn;
	// }

	// public static function getLeastTravelledVehicles($aSearch){
	// 	$sSQL = 'SELECT drd.vehicle_number,count(drd.id) as absent_count,
	// 			(select vehicle_number from vehicle_master where id = drd.vehicle_number) as vehicle_number_str,(select Pakage_name from admin_pakages adv left join vehicle_master vm on adv.id=vm.Pakage_id where vm.id = drd.vehicle_number) as Pakage_name,SUM(drd.distance) as total_distance FROM daily_route_details drd 
	// 			WHERE drd.current_day BETWEEN '.$aSearch['start_date'].' AND '.$aSearch['end_date'].'
	// 			group by vehicle_number having absent_count > 0 order by total_distance ASC limit 25';
	// 	$rData = DB::select( DB::raw($sSQL));
	// 	$aReturn = array();
	// 	foreach($rData as $aRes){
	// 		$aReturn[] = (array)$aRes; 
	// 	}
	// 	return $aReturn;	
	// }
	
	public static function get_Pakagewise_fine($aSearch){
		$startdate = $aSearch['date'];
		$enddate   = $aSearch['date'];

		$start_date = strtotime($startdate);
		$end_date   = strtotime('+1 day',$start_date) - 1;
		//dd($end_date);

		$sSQL = 'select id,Pakage_name from admin_pakages where active = 1 order by Pakage_name';
		$rPakages = DB::select( DB::raw($sSQL));	

		$aReturn['data'] = array();
		$total_tons = 0;
		$total_Pakage = 0;

		$chekpointFine = config('custom.checkpoints_fine');
		$absentFine    = config('custom.absent_fine'); 
		$employeeFine  = config('custom.employeeFine'); 

		$total_absentFine = 0;
		$total_chekpointFine = 0;
		$total_missing_employeesFine = 0;
		$total_fine = 0;
		$total_chekpointFine_time_deviation = 0;
		$total_route_deviation_fine = 0;

		foreach($rPakages as $aPakage){
			$total_Pakage += 1;
			$aReturn['data'][$aPakage->id] = $aPakage;

			/* FINE */
			/* CONSTRUCT TEMPARARY SEARCH FOR CALCULATION OF FINE */
			$aTmpSearch = array();
			$apResult['present'] =  array();
			$aTmpSearch['Pakage_id'] = $aPakage->id;
           
			$aTotalVehicles = VehicleTrakingReportModel::get_no_of_total_vehicles($aSearch['date'],$aTmpSearch);
			$apResult = HomeModel::get_no_of_present_vehicles($aSearch['date'],$aTmpSearch);
			//dd($aTotalVehicles);
			//------------------- Absent Vehicles Count -----------------------------
			// if(!empty($apResult['present'])){
			// 	$absent = $aTotalVehicles['total_vehicles'] - $apResult['present'];
			// }else{
			// 	$absent = $aTotalVehicles['total_vehicles'] - 0;
			// }

			$present_count = (isset($apResult[$aSearch['date']])) ? $apResult[$aSearch['date']] : 0;
					//echo '<br>day:'.$aRes['current_day'];
			$absent = $aTotalVehicles['total_vehicles'] - $present_count; 
			
			$absent = ($absent > 0) ? $absent : 0;
			$aRes['absentFine'] = $absent * $absentFine;
			//dd($absent);

			

			//------------------ Checkpoints Fine -------------------------
			// Count of Vehicles(Avg time of achieved checkpoints more than 1 hour)		
			$no_of_veh_chk_avg_more_than_hours = VehicleTrakingReportModel::get_total_avg_more_than_1_h_new($aSearch['date'],$aTmpSearch);
			$aRes['no_of_veh_chk_avg_more_than_hours'] = $no_of_veh_chk_avg_more_than_hours;
			$aRes['chekpointFine'] = $no_of_veh_chk_avg_more_than_hours['failedCheckpoints'] * $chekpointFine;
			//dd($aRes['chekpointFine']);
            //----------- to change for dashboard pi chart for match fine 
			// $no_of_veh_chk_avg_more_than_hours = VehicleTrakingReportModel::get_total_avg_more_than_1_h($aSearch['date'],$aTmpSearch);
			// $aRes['no_of_veh_chk_avg_more_than_hours'] = $no_of_veh_chk_avg_more_than_hours;
			// $aRes['chekpointFine'] = $no_of_veh_chk_avg_more_than_hours * $chekpointFine;

			//--------------- Employee Fine ------------------------------
			$missing_employees = VehicleTrakingReportModel::get_no_of_missing_employees($aSearch['date'],$aTmpSearch);
			$aRes['missing_employees'] = $missing_employees;
			$aRes['missing_employeesFine'] = $missing_employees * $employeeFine;

			//------------- Time Deviation Checkpoint Fine -------------------------
			$aRes['chekpointFine_time_deviation'] = $no_of_veh_chk_avg_more_than_hours['timeDeviation'];
			//---------------------------------------------------
			$aVehTypeVal = 'household';
            if($aVehTypeVal == 'household')
				$rouet_deviation_fine_details = HomeModel::get_route_deviation_fine_new($startdate,$enddate,$aVehTypeVal,$aTmpSearch);
			else  
				$rouet_deviation_fine_details = array();

			$aRes['rouet_deviation_fine'] = (isset($rouet_deviation_fine_details[$aSearch['date']])) ? $rouet_deviation_fine_details[$aSearch['date']] : 0;

            //dd($rouet_deviation_fine_details);
			$total_absentFine += $aRes['absentFine'];
			$total_chekpointFine += $aRes['chekpointFine'];
			$total_missing_employeesFine += $aRes['missing_employeesFine'];
			$total_chekpointFine_time_deviation += $aRes['chekpointFine_time_deviation'];
			$total_route_deviation_fine += $aRes['rouet_deviation_fine'];

			$tmp_total_fine = $aRes['absentFine'] + $aRes['chekpointFine'] + $aRes['missing_employeesFine'] + $aRes['chekpointFine_time_deviation'] + $aRes['rouet_deviation_fine'];
			$total_fine += $tmp_total_fine;

			$aReturn['data'][$aPakage->id]->fine_total = $tmp_total_fine;	
			$aReturn['data'][$aPakage->id]->fine_absentFine = $aRes['absentFine'];	
			$aReturn['data'][$aPakage->id]->fine_chekpointFine = $aRes['chekpointFine'];	
			$aReturn['data'][$aPakage->id]->fine_missing_employeesFine =  $aRes['missing_employeesFine'];
			$aReturn['data'][$aPakage->id]->chekpointFine_time_deviation =  $aRes['chekpointFine_time_deviation'];
			$aReturn['data'][$aPakage->id]->rouet_deviation_fine =  $aRes['rouet_deviation_fine'];
	
		}
	    $aReturn['total_Pakages'] = $total_Pakage;
		$aReturn['total_absentFine'] = $total_absentFine;
		$aReturn['total_chekpointFine'] = $total_chekpointFine;
		$aReturn['total_missing_employeesFine'] = $total_missing_employeesFine;
		$aReturn['total_time_deviation'] = $total_chekpointFine_time_deviation;
		$aReturn['total_time_deviation'] = $total_route_deviation_fine;
		$aReturn['total_deviation_fine'] = $total_fine;
		// echo '<pre>';print_r($aReturn);die;
		return (array)$aReturn;
	}

	public static function get_no_of_present_vehicles($aSearch,$aTmpSearch){
		//dd($aTmpSearch);
		//$current_day = date('Ymd',$aSearch);
        $sPSQL = 'SELECT current_day,count(drd.id) as present 
					FROM daily_route_details drd  
					LEFT JOIN route_master rm ON drd.route_id = rm.id 
				WHERE 
				drd.is_present = 1'; 
       //echo $sPSQL; die;
		if(!empty($aSearch['vehicle_type']))
			$sPSQL .= ' AND drd.type = '.$aSearch['vehicle_type'];
		if(!empty($aTmpSearch['Pakage_id']))
			$sPSQL .= ' and rm.Pakage_id = '.$aTmpSearch['Pakage_id'];
		
		$sPSQL .= ' GROUP BY current_day';
		//echo $sPSQL; die;
		$rDevRes = DB::select( DB::raw($sPSQL), array());
		// $Result = array();
		// $Result = collect($rDevRes)->first();
		// return (array)$Result;
		$Result = array();
		foreach($rDevRes as $aDevRes){
			$Result[$aDevRes->current_day] = $aDevRes->present;
		}
		return (array)$Result;
	}

    public static function get_route_deviation_fine_new($startdate,$enddate,$aVehTypeVal,$aSearch){
  
		$config_deviation_fines = config('custom.deviation_fine');
		
	  	$fine_start_day = config('custom.deviation_fine_start_day_ymd');
		$sSQL = 'SELECT drd.vehicle_number,drd.route_id,
					(select vehicle_number from vehicle_master where id=drd.vehicle_number) as vehicle_number ,
					drd.current_day,drd.default_points,drd.cover_points,drd.type
			FROM daily_route_details drd 
			LEFT JOIN route_master rm ON rm.id = drd.route_id 
			WHERE 
			drd.type IN (1,6)
			AND current_day>='.$startdate.' AND current_day<='.$enddate;
			//echo $sSQL;die;
		if(!empty($aSearch['Pakage_id'])){
			$sSQL .= ' AND rm.Pakage_id = '.$aSearch['Pakage_id'];
		}
		$sSQL .= ' ORDER BY current_day'; 
		//echo '<br>'.$sSQL;
		$rDevRes = DB::select( DB::raw($sSQL), array());
		$deviationFine = array();
		$aRoutes = array();
		if($rDevRes > 0){
			foreach($rDevRes as $aDevRes){
				if(!isset($aRoutes[$aDevRes->current_day])){
					$aRoutes[$aDevRes->current_day] = array();
				}
				if(array_key_exists($aDevRes->route_id,$aRoutes[$aDevRes->current_day])){
					//echo '<br>Iamhere----';
					//echo '<pre>aRoutes:';print_r($aRoutes[$aDevRes->current_day][$aDevRes->route_id]);
					$aDevRes->cover_points += $aRoutes[$aDevRes->current_day][$aDevRes->route_id]['cover_points'];
					if($aDevRes->default_points == 0){
						$aDevRes->default_points = $aRoutes[$aDevRes->current_day][$aDevRes->route_id]['default_points'];
					}
					if($aDevRes->cover_points > $aDevRes->default_points)
						$aDevRes->cover_points = $aDevRes->default_points;
					//echo 'cover points:'.$aDevRes->cover_points;
					//echo '<pre>first : ';print_r($aDevRes);
				}
				//echo '<pre>aDevRes:';print_r($aDevRes);
				$aRoutes[$aDevRes->current_day][$aDevRes->route_id]['default_points'] = $aDevRes->default_points;
				$aRoutes[$aDevRes->current_day][$aDevRes->route_id]['cover_points'] = $aDevRes->cover_points;
				$aRoutes[$aDevRes->current_day][$aDevRes->route_id]['data'] = $aDevRes;
			}

			//dd($aRoutes);
			foreach($aRoutes as $dates=>$values){
				//echo $dates;	die;
				$deviationFine[$dates] = 0;
				foreach($values as $aDevRes){
					$coveragePercentage = !empty($aDevRes['default_points']) ? ($aDevRes['cover_points']/$aDevRes['default_points'])*100 : 0;
					$percentage = ceil($coveragePercentage);
					$deviation_percentage = (100 - $percentage);
					
					$fine = 0;
					//echo '<br>per:'.$percentage;
					if($percentage >= 95 && $percentage <= 100){
						$fine = $config_deviation_fines['95_to_100'];

					}else if($percentage >= 90 && $percentage <= 94){
						$fine = $config_deviation_fines['90_to_94'];

					}else if($percentage >= 80 && $percentage <= 89){
						$fine = $config_deviation_fines['80_to_89'];

					}else if($percentage >= 70 && $percentage <= 79){
						$fine = $config_deviation_fines['70_to_79'];

					}else if($percentage >= 60 && $percentage <= 69){
						$fine = $config_deviation_fines['60_to_69'];

					}else if($percentage >= 50 && $percentage <= 59){
						$fine = $config_deviation_fines['50_to_59'];

					}else if($percentage < 50){
						$fine = $config_deviation_fines['less_than_50'];

					}
					
					$deviationFine[$dates] += $fine;
				}
			}
		}
		$start_date_timestamp   = strtotime($startdate);
		$end_date_timestamp 	  = strtotime('+1 day',strtotime($enddate)) - 1;
		
		while($start_date_timestamp <= $end_date_timestamp){
			$deviationFine[date('Ymd',$start_date_timestamp)] = (isset($deviationFine[date('Ymd',$start_date_timestamp)])) ? $deviationFine[date('Ymd',$start_date_timestamp)] : 0;
			$start_date_timestamp = strtotime('+1 day',$start_date_timestamp);
		}
		//echo '<pre>';print_r($deviationFine);die;
		return $deviationFine;
	}

	public static function get_Pakagewise_coverage($aSearch){
		

		$sSQL = 'select id,Pakage_name from admin_pakages where active = 1 order by Pakage_name';
		$rPakages = DB::select( DB::raw($sSQL));	
		$aResposne = array();
		$divColors  = config('custom.divColors'); 
		//echo '<pre>';print_r($divColors);die;
		foreach($rPakages as $aPakage){
			$sSQL = 'SELECT sum(default_points) as default_points,sum(cover_points) as cover_points
				FROM daily_route_details drd 
				LEFT JOIN route_master rm ON rm.id = drd.route_id 
				WHERE 
				drd.type IN (1,6)
				AND rm.Pakage_id = '.$aPakage->id.'
				AND current_day='.$aSearch['date'];
			
				$rDevRes = DB::select( DB::raw($sSQL), array());
				
				$deviationFine = array();
				$aRoutes = array();
				if($rDevRes > 0){
					$aDiv['Pakage_id'] = $aPakage->id;
					$aDiv['Pakage_name'] = $aPakage->Pakage_name;
					$aDiv['color'] = (isset($divColors[$aPakage->id])) ? $divColors[$aPakage->id] : '#000000';
					$aDiv['default_points'] = $rDevRes[0]->default_points;
					$aDiv['percent'] = 0;
					if($rDevRes[0]->default_points > 0)
						$aDiv['percent'] = round(($rDevRes[0]->cover_points /  $rDevRes[0]->default_points ) * 100);
					$aResposne[] = $aDiv;
				}
		}
		return $aResposne;
	}
}
