@extends('layout.index')
@section('title','Water Tanker Visit Report')

<!-- Dashboard Ecommerce start -->
@section('content')
<section>
    <div class="content-body">
        <!-- Bordered table start -->
        <div class="row" id="table-bordered">
           <div class="col-12">
              <div class="card">
                 <div class="card-header w-100" >
                    <div class="content-header-left">
                       <div class="row breadcrumbs-top">
                          <div class="col-sm-12">
                             <h2 class="content-header-title float-left mb-0">Water Tanker Visit Report List</h2>
                          </div>
                       </div>
                    </div>
                    <div class="d-flex justify-content-end breadcrumb-wrapper">
                       <nav aria-label="breadcrumb">
                          <ol class="breadcrumb mr-1">
                             <li class="breadcrumb-item"><a href="javascript:void(0)">Home</a></li>
                             <li class="breadcrumb-item">Water Tanker Visit Report</li>
                             <li class="breadcrumb-item active" aria-current="page">Water Tanker Visit Report List</li>
                          </ol>
                       </nav>
                    </div>
                 </div>
              </div>
           </div>
        </div>
        <!-- Bordered table end -->
    </div>
        @if ($message = Session::get('success'))
            <div class="demo-spacing-0 mb-1">
                <div class="alert alert-success alert-dismissible fade show" role="alert">
                    <div class="alert-body">
                        <i class="fa fa-check-circle" style="font-size:16px;" aria-hidden="true"></i>
                            {{ $message }}
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">

                    </div>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                    </button>
                </div>
            </div>
        @endif

    <div class="content-body">
        <!-- Bordered table start -->
        <div class="row" id="table-bordered">
            <div class="col-12">
                <div class="card">
                    <form class="dt_adv_search" action="{{url('/vehicle_tracking_reports/water_tanker_visit_report')}}" method="POST">
                            @csrf
                        <div class="card-header w-100" >
                            <div class="row w-100" >
                                <div class="col-sm-8">
                                    <div class="row">

                                        <div class="col-sm-3">
                                            <div class="form-group m-0">
                                            <input type="text" id="txt_from_date" class="form-control flatpickr-basic" name="txt_from_date" placeholder="Start Date" value="<?php echo session('search_from_date_w'); ?>"/>
                                            </div>
                                            <h5><small class="text-danger" id="txt_from_date_err"></small></h5>
                                        </div>

                                        <div class="col-sm-3">
                                            <div class="form-group m-0">
                                            <input type="text" id="txt_to_date" class="form-control flatpickr-basic" name="txt_to_date" placeholder="End Date" value="<?php echo session('search_to_date_w'); ?>"/>
                                            </div>
                                            <h5><small class="text-danger" id="txt_to_date_err"></small></h5>
                                        </div>

                                        <div class="col-sm-3">
                                            <div class="form-group m-0">
                                            <select name="packege_id" id="packege_id" class="select2 form-select">
                                                <option value="">--- Select Package ---</option>
                                                <?php 
                                                  if(!empty($pakages)){
                                                  
                                                  foreach ($pakages as $val) {
                                                   
                                                   $selected = ($val->id == session('search_packege_id_w'))? 'selected':'';   
                                                ?>
                                                <option value="<?php echo $val->id ?>" <?php echo $selected; ?>><?php echo $val->Pakage_name ?></option>
                                                <?php
                                                   }
                                                  }
                                                 ?>
                                            </select>
                                            </div>
                                        </div>

                                        <div class= "col-sm-3">
                                           
                                           <button type="submit" name="btn_search" class="btn btn-primary" onclick="return validation();">Search</button>
                                            
                                            @if(session('search_from_date_w') || session('search_to_date_w') || session('search_packege_id_w'))
                                              <button type="submit" name="btn_reset" class="btn btn-outline-primary"><i data-feather="rotate-ccw" class="me-25"></i> Clear</button>
                                            @endif 
                                        </div>
                                    </div>
                                </div>
                                <div class="col-sm-4">
                                    <div style="float: right;">
                                        <a href="{{ url('vehicle_tracking_reports/water_tanker_visit_report_excel') }}" 
                                        class="btn btn-outline-primary"><i class='fa fa-download' arial-hidden="true"></i> Excel</a>
                                     
                                        <a href="{{ url('/vehicle_tracking_reports') }}" 
                                        class="btn btn-outline-primary"><span>Back</span></a>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>
                <!-- index.blade.php -->

<div class="table-responsive">
    <table class="table table-striped table-bordered">
        <thead>
            <tr>
                <th style="background-color:#29204f;color: #ffffff;" class="text-center">SR.NO</th>
                <th style="background-color:#29204f;color: #ffffff;" class="text-center">Vehicle Number</th>
                <th style="background-color:#29204f;color: #ffffff;" class="text-center">Package</th>
                <th style="background-color:#29204f;color: #ffffff;" class="text-center">Date</th>
                <th style="background-color:#29204f;color: #ffffff;" class="text-center">Dumping Visit Time</th>
            </tr>
            
        </thead>
        <tbody class="text-left">
            
            <?php 
              $i_no = 0;
              if(!empty($records)){

                foreach ($records as $val) {
                
                $i_no++;   
            ?>    
                 
                <tr>
                    <td style="background-color:#10bcf15c" class="text-center"><?php echo $i_no; ?></td>
                    <td style="background-color:#10bcf15c" class="text-center"><?php echo $val->vehicle_number; ?></td>
                    <td style="background-color:#10bcf15c" class="text-center"><?php echo $val->Pakage_name; ?></td>
                    <td style="background-color:#10bcf15c" class="text-center"><?php echo ($val->current_day)? date('d-m-Y',strtotime($val->current_day)):''; ?></td>
                    <td style="background-color:#10bcf15c" class="text-center"><?php echo ($val->dumping_visit_time_date)? date('h:i:s',strtotime($val->dumping_visit_time_date)):''; ?></td>
                </tr>
            <?php 
                }
              }else{
            ?>          
            <tr>
                <td colspan="5" style="text-align:center; color:red;">No Record Found</td>
            </tr>
            <?php 
                }
            ?> 
        </tbody>
    </table>
</div>

                </div>

            </div>
        </div>
        <!-- Bordered table end -->
    </div>
</section>

<script>
    function validation(){

        if ($('#txt_from_date').val() != "" && $('#txt_to_date').val() != ""){

            if(new Date($('#txt_to_date').val()) < new Date($('#txt_from_date').val())){
                 
                $('#txt_to_date').parent().addClass('has-error');
                $('#txt_to_date_err').html('Please End Date Greater than Equal to Start Date.');
                $('#txt_to_date').focus();
                $('#txt_to_date').change(function () {
                $('#txt_to_date').parent().removeClass('has-error');
                $('#txt_to_date_err').html('');
               });
               return false;
            }
            
        }
    }
</script>

@endsection
