@extends('layout.index')
@section('title', 'Supervisor Assign Wards')
<!-- Dashboard Ecommerce start -->
@section('content')
    <section>

        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header w-100">
                            <div class="content-header-left">
                                <div class="row breadcrumbs-top">
                                    <div class="col-sm-12">
                                        <h2 class="content-header-title float-left mb-0">Assign Wards</h2>
                                    </div>
                                </div>
                            </div>
                            <div class="d-flex justify-content-end breadcrumb-wrapper">
                                <nav aria-label="breadcrumb">
                                    <ol class="breadcrumb mr-1">
                                        <li class="breadcrumb-item"><a href="javascript:void(0)">Home</a></li>
                                        <li class="breadcrumb-item">Supervisor</li>
                                        <li class="breadcrumb-item active" aria-current="page">Add/Edit Assign Wards </li>
                                    </ol>
                                </nav>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- Bordered table end -->
        </div>

        @if ($message = Session::get('success'))
            <div class="demo-spacing-0 mb-1">
                <div class="alert alert-success alert-dismissible fade show" role="alert">
                    <div class="alert-body">
                        {{-- <i class="fa fa-exclamation-triangle" aria-hidden="true"></i> --}}
                        {{ $message }}
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">

                    </div>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
            </div>
        @endif

        @if ($message = Session::get('error'))
            <div class="demo-spacing-0 mb-1">
                <div class="alert alert-danger alert-dismissible fade show" role="alert">
                    <div class="alert-body">
                        {{-- <i class="fa fa-exclamation-triangle" aria-hidden="true"></i> --}}
                        {{ $message }}
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">

                    </div>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
            </div>
        @endif

        <div class="content-body">
            <!-- Basic multiple Column Form section start -->
            <section id="multiple-column-form">
                <div class="row justify-content-center">
                    <div class="col-sm-12">
                        <div class="card">
                            <div class="card-body">
                                <?php if(!empty($aSupedit)){ ?> 
                                    <form class="form" action="{{ url('/supervisors/add_wards/update/'.$aSupervisor->id.'/'.$aSupedit[0]->id) }}" method="POST">
                                <?php }else{?>
                                    <form class="form" action="{{ url('/supervisors/add_wards') }}" method="POST">
                                <?php } ?>
                                    {{ csrf_field() }}
                                    <div class="row">
                                        <div class="col-md-4 col-12">
                                            <input type="hidden" id="supervisor_id" class="form-control"
                                                name="supervisor_id" value="{{ $aSupervisor->id }}" />
                                            
                                            <input type="hidden" id="Pakage_id" class="form-control"
                                                name="Pakage_id" value="{{ $aSupervisor->Pakage_id }}" />

                                            <div class="form-group">
                                                <label for="select2 form-select">Ward Name <span style="color:red;">*</span></label>
                                                <select class="select2 form-select" id="ward_id" name="ward_id">
                                                <option value="">--All Wards--</option>
                                                @foreach($wards as $val)
                                               
                                                @php $selected = '';   @endphp 
                                                @if(!empty($aSupedit))
                                                    @if($aSupedit[0]->ward_id == $val->id)
                                                        @php $selected ='selected'; @endphp
                                                    @endif
                                                @endif
                                                    <option {{ $selected }} value="{{ $val->id }}">{{ $val->ward_name }}</option>
                                                @endforeach 
                                                </select>
                                                <h5><small class="text-danger" id="ward_id_err"></small></h5>
                                            </div>
                                        </div>
                                      
                                        <div class="col-4 text-center mt-2">
                                            
                                            <button type="submit" class="btn btn-primary mr-1" onClick="return validation()">Submit</button>
                                            <a href="{{ route('supervisors.index') }}" type="reset"
                                                class="btn btn-outline-secondary">Cancel</a>
                                        </div>
                                        <div class="col-4 text-center mt-1"></div>
                                    </div>
                                </form>
                              
                                    <div class="table-responsive mt-5">
                                        <strong>Supervisor Name :-</strong> <?php echo ucfirst($aSupervisor->supervisor_name); ?> 
                                        <table class="table table-striped table-bordered">
                                            <thead>
                                                <tr>
                                                    <th class="text-center">Sr No.</th>
                                                    <th class="text-left"> Ward name</th>
                                                    <th class="text-center">Action</th>
                                                </tr>
                                            </thead>
                                            <tbody class="text-center">
                                            @if($aSupervisor)
                                                @if(count($aResult) != 0)
                                                    @php $i=0;
                                                    @endphp
                                                        @foreach($aResult as $val)  
                                                        @php
                                                            $i++;
                                                        @endphp     
                                                        <tr>
                                                            <input type="hidden" id="supervisor_id" class="form-control"
                                                                name="supervisor_id" value="{{ $aSupervisor->id }}" />
                                                            <td class="text-center">{{ $i }}</td>
                                                            <td class="text-left">{{ $val->ward_name }}</td>
                                                            <td class="text-center">
                                                            <div class="dropdown">
                                                                <button type="button" class="btn btn-sm dropdown-toggle hide-arrow"
                                                                    data-toggle="dropdown">
                                                                    <i data-feather="more-vertical"></i>
                                                                </button>
                                                                <div class="dropdown-menu">
                                                                <a class="dropdown-item"
                                                                        href="{{ url('/supervisors/assignward/'.$aSupervisor->id.'/'.$val->id) }}">
                                                                        <i data-feather="edit-2" class="mr-50"></i>
                                                                        <span>Edit</span>
                                                                    </a>
                                                               
                                                                    <button type="submit" class="dropdown-item" onclick="delete_wards({{ $val->id }}, {{  $aSupervisor->id }});">
                                                                        <i data-feather="trash" class="mr-50" ></i>Delete
                                                                    </button>
                                                                </div>
                                                            </div>
                                                            </td>
                                                        </tr>
                                                    @endforeach
                                                    @else
                                                    <tr>
                                                        <td colspan="3" style="text-align:center; color:red;">Record Not Found</td>
                                                    </tr>
                                                    @endif 
                                                    @endif 
                                            </tbody>
                                        </table>
                                    </div>
                              
                            </div>
                        </div>
                    </div>
                </div>
        </div>
    </section>
    </div>
    </section>
    <!-- Basic Floating Label Form section end -->
    </div>
    <?php $live_url = config('custom.base_url'); ?>
    </section>
@endsection
    
<script>

    function delete_wards(ward_id, supervisor_id) {
        //console.log(ward_id);
       // alert(supervisor_id);
       // console.log(supervisor_id);
        if(confirm('Are you sure you want to delete this record?')){
            
            $.ajax({
               // url: '/supervisors/remove/remove_wards',
                url: "<?php echo $live_url; ?>supervisors/remove/remove_wards",
                type: 'post',
                data: {
                    "_token": "{{ csrf_token() }}",
                    ward_id: ward_id,
                    supervisor_id: supervisor_id
                },

                success: function (result) {
                   // alert(result);
                   location.reload();
                }
            });
        }
       
    }


	function validation() {

        if ($('#ward_id').val() == ""){
            $('#ward_id').parent().addClass('has-error');
            $('#ward_id_err').html('Please Select Ward Name.');
            $('#ward_id').focus();
            $('#ward_id').change(function () {
            $('#ward_id').parent().removeClass('has-error');
            $('#ward_id_err').html('');
            });
            return false;
        } 
    }
</script>


