@extends('layout.index')
@section('title', 'Supervisor Device Create')
<!-- Dashboard Ecommerce start -->
@section('content')
    <section>

        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header w-100">
                            <div class="content-header-left">
                                <div class="row breadcrumbs-top">
                                    <div class="col-sm-12">
                                        <h2 class="content-header-title float-left mb-0">Add Supervisor Device</h2>
                                    </div>
                                </div>
                            </div>
                            <div class="d-flex justify-content-end breadcrumb-wrapper">
                                <nav aria-label="breadcrumb">
                                    <ol class="breadcrumb mr-1">
                                        <li class="breadcrumb-item"><a href="javascript:void(0)">Home</a></li>
                                        <li class="breadcrumb-item">Supervisor</li>
                                        <li class="breadcrumb-item active" aria-current="page">Add Supervisor Devices </li>
                                    </ol>
                                </nav>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- Bordered table end -->
        </div>

        @if ($message = Session::get('success'))
            <div class="demo-spacing-0 mb-1">
                <div class="alert alert-success alert-dismissible fade show" role="alert">
                    <div class="alert-body">
                        {{-- <i class="fa fa-exclamation-triangle" aria-hidden="true"></i> --}}
                        {{ $message }}
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">

                    </div>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
            </div>
        @endif

        <div class="content-body">
            <!-- Basic multiple Column Form section start -->
            <section id="multiple-column-form">
                <div class="row justify-content-center">
                    <div class="col-sm-12">
                        <div class="card">
                            <div class="card-body">
                                <form class="form" action="{{ url('/supervisors/submit_devices') }}" method="POST">
                                    {{ csrf_field() }}
                                    <div class="row">
                                        <div class="col-md-6 col-12">
                                            <input type="hidden" id="supervisor_id" class="form-control"
                                                name="supervisor_id" value="{{ $aSupervisor->id }}" />

                                            <div class="form-group">
                                                <label for="user_name">User Name <span style="color:red;">*</span></label>
                                                <input type="text" id="user_name" class="form-control"
                                                    placeholder="User Name" name="user_name" value="{{ old('user_name') }}" autocomplete="off" />
                                                <h5><small class="text-danger" id="user_name_err"></small></h5>
                                                @error('user_name')
                                                    <span class="error" style="color:red;">{{ $message }}</span>
                                                @enderror
                                            </div>
                                        </div>
                                        <div class="col-md-6 col-12">
                                            <div class="form-group">
                                                <label for="device_id">Device Id <span style="color:red;">*</span></label>
                                                <input type="text" id="device_id" class="form-control"
                                                    placeholder="Device Id" name="device_id" autocomplete="off" value="{{ old('device_id') }}" />
                                                <h5><small class="text-danger" id="device_id_err"></small></h5>
                                                @error('device_id')
                                                    <span class="error" style="color:red;">{{ $message }}</span>
                                                @enderror
                                            </div>
                                        </div>

                                        <div class="col-12 text-center mt-1">
                                            <button type="submit" class="btn btn-primary mr-1" onClick="return validation()">Submit</button>
                                            <a href="{{ route('supervisors.index') }}" type="reset"
                                                class="btn btn-outline-secondary">Cancel</a>
                                        </div>
                                    </div>
                                </form>
                                @if (sizeof($aAllDevices) > 0)
                                    <div class="table-responsive mt-5">
                                        <table class="table table-striped table-bordered">
                                            <thead>
                                                <tr>
                                                    <th class="text-center">Sr No.</th>
                                                    <th class="text-left"> User name</th>
                                                    <th class="text-left">Device Id</th>
                                                    <th class="text-center">Action</th>
                                                </tr>
                                            </thead>
                                            <tbody class="text-center">
                                                @if ($aAllDevices)
                                                    @php
                                                        $i = 0;
                                                    @endphp
                                                    @foreach ($aAllDevices as $val)
                                                        @php
                                                            $i++;
                                                        @endphp
                                                        <tr>
                                                            <input type="hidden" id="supervisor_id" class="form-control"
                                                                name="supervisor_id" value="{{ $aSupervisor->id }}" />
                                                            <td class="text-center">{{ $i }}</td>
                                                            <td class="text-left"> {{ $val->user_name }}</td>
                                                            <td class="text-left"> {{ $val->device_id }}</td>
                                                            <td class="text-center"> 
                                                                <div class="dropdown">
                                                                    <button type="button" class="btn btn-sm dropdown-toggle hide-arrow"
                                                                        data-toggle="dropdown">
                                                                        <i data-feather="more-vertical"></i>
                                                                    </button>
                                                                    <div class="dropdown-menu">
                                                                        <a class="dropdown-item"
                                                                        href="{{ url('/supervisors/devices/edit/'.$val->id.'/'.$aSupervisor->id) }}">
                                                                        <i data-feather="edit-2" class="mr-50"></i>
                                                                        <span>Edit</span>
                                                                    </a>
                                                                            
                                                                    <button type="submit" class="dropdown-item" onclick="delete_devices({{ $val->id }}, {{  $aSupervisor->id }});">
                                                                        <i data-feather="trash" class="mr-50" ></i>Delete
                                                                        </button>
                                                                    </div>
                                                                </div>
                                                                {{-- <button type="submit" class="btn mr-1 col-sm-6" style="color: red; font-size:25px;"><i class="fa fa-trash"
                                                                aria-hidden="true" onclick="delete_devices({{ $val->id }}, {{  $aSupervisor->id }});"></i></button> --}}
                                                            </td> 
                                                        </tr>
                                                    @endforeach
                                                @else
                                                    <tr>
                                                        <td colspan="4">No devices</td>
                                                    </tr>
                                                @endif
                                            </tbody>
                                        </table>
                                    </div>
                                @endif
                            </div>
                        </div>
                    </div>
                </div>
        </div>
    </section>
    </div>
    </section>
    <!-- Basic Floating Label Form section end -->
    </div>
    <?php $live_url = config('custom.base_url'); ?>
    </section>
@endsection
    
<script>

    function delete_devices(device_id, supervisor_id) {
        //console.log(device_id);
        //console.log(supervisor_id);
        if(confirm('Are you sure you want to delete this record?')){
            
            $.ajax({
                //url: '/supervisors/remove/device',
                url: "<?php echo $live_url; ?>supervisors/remove/device",
                type: 'post',
                data: {
                    "_token": "{{ csrf_token() }}",
                    device_id: device_id,
                    supervisor_id: supervisor_id
                },

                success: function (result) {
                    alert('Supervisor devices deleted successfully.');
                    location.reload();
                }
            });
        }
       
    }

	function validation() {

        if ($('#user_name').val() == ""){
            $('#user_name').parent().addClass('has-error');
            $('#user_name_err').html('Please Enter User Name.');
            $('#user_name').focus();
            $('#user_name').keyup(function () {
            $('#user_name').parent().removeClass('has-error');
            $('#user_name_err').html('');
            });
            return false;
        } 
        
        if ($('#device_id').val() == ""){
            $('#device_id').parent().addClass('has-error');
            $('#device_id_err').html('Please Enter Device Id.');
            $('#device_id').focus();
            $('#device_id').keyup(function () {
            $('#device_id').parent().removeClass('has-error');
            $('#device_id_err').html('');
            });
            return false;
        }
    }
</script>


