@extends('layout.index')
@section('title', 'Date-wise Single Pakage Weight Report')

<!-- Dashboard Ecommerce start -->
@section('content')
    @php
    use Carbon\Carbon;
    @endphp
    <section>
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header w-100">
                            <div class="content-header-left">
                                <div class="row breadcrumbs-top">
                                    <div class="col-sm-12">
                                        <h2 class="content-header-title float-left mb-0">Date-wise Single Pakage Weight Report </h2>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- Bordered table end -->
        </div>
     
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <form class="dt_adv_search" action="{{ url('/vehicle_tracking_reports/date_wise_weight_mngmt') }}" method="POST">
                            @csrf
                            <input type="hidden" name="form_type" value="search_frm">
                            <div class="card-header w-100">
                                <div class="row w-100">
                                    <div class="col-sm-10">
                                        <div class="row">
                                            <div class="col-sm-2">
                                                <div class="form-group m-0">
                                                    <label class="form-label">Pakage</label>
                                                    <select class="select2 form-select" id="Pakage_id" name="Pakage_id">
                                                        <option value="">--- All Pakage ---</option>
                                                        @foreach($Pakages as $val)

                                                            @php $selected = '';   @endphp 
                                                            @if($Pakage_id == $val->id)
                                                            @php $selected ='selected'; @endphp
                                                            @endif
                                                        <option {{ $selected }} value="{{ $val->id }}">{{ $val->Pakage_name }}</option>
                                                        @endforeach 
                                                    </select>
                                                    <h5><small class="text-danger" id="Pakage_id_err"></small></h5>
                                                </div>
                                            </div>

                                            <div class="col-sm-2">
                                                <label class="form-label">Vehicle Type</label>
                                                <select name="vehicle_type_id" id="vehicle_type_id" class="select2 form-select">
                                                    <option value="0">--- All Vehicle Types ---</option>
                                                    @foreach($vehicle_type as $val)

                                                        @php $selected = '';  @endphp 
                                                        @if($vehicle_type_id == $val->id)
                                                        @php $selected ='selected'; @endphp
                                                        @endif
                                                    <option {{ $selected }} value="{{$val->id}}">{{$val->type }}</option>
                                                    @endforeach  
                                                </select>
                                            </div>

                                            <div class="col-sm-2">
                                              <label class="form-label">Start Date</label>
                                              <input id="start_date" name="start_date" class="form-control flatpickr-basic" type="text" value="<?php echo $start_date; ?>" >
                                            </div>

                                            <div class="col-sm-2">
                                              <label class="form-label">End Date</label>
                                              <input id="end_date" name="end_date" class="form-control flatpickr-basic" type="text" value="<?php echo $end_date; ?>" >
                                            </div>


                                            <div class="col-sm-2">
                                                <label class="form-label">&nbsp;</label><br>
                                                    <button type="submit" class="btn btn-primary" onClick="return validation()">Search</button>
                                                    @if ($search) 
                                                      <a title="Clear" href="{{ url('/vehicle_tracking_reports/clear_search/date_wise_weight_mngmt') }}" type="button" class="btn btn-outline-primary"><i data-feather="rotate-ccw" class="me-25"></i> Clear </a>
                                                    @endif
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-sm-2">
                                    <label class="form-label">&nbsp;</label>
                                        <div class="d-flex align-items-center justify-content-end">
                                            @if($Pakage_id)
                                                <a title="Clear" href="{{ url('/vehicle_tracking_reports/date_wise_weight_mngmt/export_excel') }}"  style="margin: 4px;"
                                                    type="button" class="btn btn-outline-primary">
                                                    <i class='fa fa-download' arial-hidden="true"></i> Excel
                                                </a>
                                            @endif
                                                
                                            <a href="{{ url('vehicle_tracking_reports') }}" 
                                                    class="btn btn-outline-primary float-right"><span>Back</span></a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </form>
                        <div class="table-responsive">
                            <table class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th class="text-center">Sr.No</th>
                                        <th class="text-left">Date</th>
                                        <th class="text-center">Loaded Weight</th>
                                        <th class="text-center">Unloaded Weight</th>
                                        <th class="text-center">Net Weight</th>
                                        <th class="text-center">Ton's</th>
                                    </tr>
                                </thead>
                                <tbody class="text-left">
                               
                                <?php 
                                   $total_tons = 0;
                                   if(!empty($PakageWeightData)){
                                        $i = 0;
                                        
                                        //$i = $PakageWeightData->perPage() *($PakageWeightData->currentPage() - 1);
                                        foreach($PakageWeightData  as $aRec){ 
                                            $i++;
                                            $total_net = $aRec->total_net;
                                         	$tons = $total_net/1000;
                                            $total_tons += $tons;
			                               
                                ?>
                                    <tr>
                                        <td class="text-center"><?php echo $i; ?></td>
                                        <td class="text-left"><?php echo date('d-m-Y',strtotime($aRec->current_day)); ?></td>
                                        <td class="text-center"><?php echo $aRec->total_loaded; ?></td>
                                        <td class="text-center"><?php echo $aRec->total_unloaded; ?></td>
                                        <td class="text-center"><?php echo $aRec->total_net; ?></td>
                                        <td class="text-center"><?php echo $tons; ?></td>
                                   </tr> 
                                   <?php } ?> 
                                    <tr>
                                        <th class="text-right" colspan="5">Total</th>
                                        <th class="text-center"><?php echo $total_tons; ?></th> 
                                    </tr>
                                    <?php }else{ ?>

                                    <tr>
                                        <td colspan="6" class="text-center" style="color:red;">No Record Found.</td>
                                    </tr>
                                   
                                    <?php } ?>
                                            
                                </tbody>
                            </table>
                            <div class="card-body">
                                <div class="d-flex justify-content-end">
                                    <?php
                                       if(!empty($PakageWeightData)){
                                        // echo $PakageWeightData->links();
                                       }
                                     ?>
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
            <!-- Bordered table end -->
        </div>
    </section>
@endsection

<script type="text/javascript">
	function validation() {

      if ($('#Pakage_id').val() == ""){
         $('#Pakage_id').parent().addClass('has-error');
         $('#Pakage_id_err').html('Please Select Pakage.');
         $('#Pakage_id').focus();
         $('#Pakage_id').change(function () {
         $('#Pakage_id').parent().removeClass('has-error');
         $('#Pakage_id_err').html('');
        });
        return false;
      }
    }  
</script>
