@extends('layout.index')
@section('title', 'Distance Travel Report')

<!-- Dashboard Ecommerce start -->
@section('content')
    @php
    use Carbon\Carbon;
    @endphp
    <section>
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header w-100">
                            <div class="content-header-left">
                                <div class="row breadcrumbs-top">
                                    <div class="col-sm-12">
                                        <h2 class="content-header-title float-left mb-0">Distance Travel Report</h2>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- Bordered table end -->
        </div>
     
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <form class="dt_adv_search" action="{{ url('/vehicle_tracking_reports/distance_travel_report') }}" method="POST">
                            @csrf
                            <input type="hidden" name="form_type" value="search_frm">
                            <div class="card-header w-100">
                                <div class="row w-100">
                                    <div class="col-sm-10">
                                        <div class="row">
                                            <div class="col-sm-2">
                                                <label class="form-label">Vehicle</label>
                                                <select name="vehicle_id" id="vehicle_id" class="select2 form-select">
                                                    <option value="0">--All Vehicles--</option>
                                                    @foreach($vehicle as $val)

                                                        @php $selected = '';  @endphp 
                                                        @if($vehicle_id == $val->id)
                                                        @php $selected ='selected'; @endphp
                                                        @endif
                                                    <option {{ $selected }}  value="{{$val->id}}">{{$val->vehicle_number }}</option>
                                                    @endforeach  
                                                </select>
                                            </div>

                                            <div class="col-sm-2">
                                                <label class="form-label">Vehicle Type</label>
                                                <select name="vehicle_type_id" id="vehicle_type_id" class="select2 form-select">
                                                    <option value="0">--- All Vehicle Types ---</option>
                                                    @foreach($vehicle_type as $val)

                                                        @php $selected = '';  @endphp 
                                                        @if($vehicle_type_id == $val->id)
                                                        @php $selected ='selected'; @endphp
                                                        @endif
                                                    <option {{ $selected }} value="{{$val->id}}">{{$val->type }}</option>
                                                    @endforeach  
                                                </select>
                                            </div>

                                            <div class="col-sm-2">
                                              <label class="form-label">Start Date</label>
                                              <input id="start_date" name="start_date" class="form-control flatpickr-basic" type="text" value="<?php echo $start_date; ?>" >
                                            </div>

                                            <div class="col-sm-2">
                                              <label class="form-label">End Date</label>
                                              <input id="end_date" name="end_date" class="form-control flatpickr-basic" type="text" value="<?php echo $end_date; ?>" >
                                            </div>


                                            <div class="col-sm-3">
                                                <label class="form-label">&nbsp;</label><br>
                                                    <button type="submit" class="btn btn-primary" >Search</button>
                                                    @if ($search) 
                                                      <a title="Clear" href="{{ url('/vehicle_tracking_reports/clear_search/distance_travel_report') }}" type="button" class="btn btn-outline-primary"><i data-feather="rotate-ccw" class="me-25"></i> Clear </a>
                                                    @endif
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-sm-2" style="float:right;">
                                       
                                        <label class="form-label">&nbsp;</label><br>
                                        <div class="d-flex align-items-center justify-content-end">
                                        @if(count($records))        
                                            <a title="Clear" href="{{ url('/vehicle_tracking_reports/distance_travel/export_excel') }}"  style="margin : 4px;"
                                                    type="button" class="btn btn-outline-primary">
                                                    <i class='fa fa-download' arial-hidden="true"></i> Excel </a>
                                        @endif   
                                            <a href="{{ url('vehicle_tracking_reports') }}" 
                                                    class="btn btn-outline-primary float-right"><span>Back</span></a>
                                        </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </form>
                        <div class="table-responsive">
                            <table class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th class="text-center">Sr.No</th>
                                        <th class="text-left">Vehicle Number</th>
                                        <th class="text-left">Distance Travelled</th>
                                    </tr>
                                </thead>
                                <tbody class="text-left">
                               
                                <?php 
                                    $total_distance_travelled = 0;
                                    if(!empty($records)){
                                    $i = 0;
                                    
                                        foreach($records as $aValue){ 
                                        $i++;

                                        $distance_km = ($aValue->distance_travelled/1000);
                                        $total_distance_travelled += $distance_km;	
                                       
                                ?>
                                    <tr>
                                        <td class="text-center"><?php echo $i; ?></td>
                                        <td class="text-left"><?php echo $aValue->vehicle_name; ?></td>
                                        <td class="text-left"><?php echo number_format($distance_km,2).' Km'; ?></td>
                                    </tr> 
                                   <?php } ?>
                                    <tr>
                                        <th colspan="2" class="text-right">Total</th>
                                        <th><?php echo number_format($total_distance_travelled,2).' Km'; ?></th>
                                    </tr>
                                   <?php }else{ ?>
                                    <tr>
                                        <td colspan="7" class="text-center" style="color:red;">No Record Found.</td>
                                    </tr>
                                   <?php } ?>
                                   
                                </tbody>
                            </table>
                            <div class="card-body">
                                <div class="d-flex justify-content-end">
                                   <!-- pagination code -->
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
            <!-- Bordered table end -->
        </div>
    </section>
@endsection

