@extends('layout.index')
@section('title', 'Vehicle Khat-Prakalpa Visit Report')

<!-- Dashboard Ecommerce start -->
@section('content')
    @php
    use Carbon\Carbon;
    @endphp
    <section>
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header w-100">
                            <div class="content-header-left">
                                <div class="row breadcrumbs-top">
                                    <div class="col-sm-12">
                                        <h2 class="content-header-title float-left mb-0"> Vehicle Khat-Prakalpa Visit Report </h2>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- Bordered table end -->
        </div>
     
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <form class="dt_adv_search" action="{{ url('/vehicle_tracking_reports/khatprakalpa_visit') }}" method="POST">
                            @csrf
                            <input type="hidden" name="form_type" value="search_frm">
                            <div class="card-header w-100">
                                <div class="row w-100">
                                    <div class="col-sm-12">
                                        <div class="row">
                                            <div class="col-sm-2">
                                                <div class="form-group m-0">
                                                    <label class="form-label">Pakage</label>
                                                    <select class="select2 form-select" id="Pakage_id" name="Pakage_id" onChange="get_wards()">
                                                        <option value="">--- All Pakage ---</option>
                                                        @foreach($Pakages as $val)

                                                            @php $selected = '';   @endphp 
                                                            @if($Pakage_id == $val->id)
                                                            @php $selected ='selected'; @endphp
                                                            @endif
                                                        <option {{ $selected }} value="{{ $val->id }}">{{ $val->Pakage_name }}</option>
                                                        @endforeach 
                                                    </select>
                                                </div>
                                            </div>

                                            <div class="col-sm-2">
                                                <label class="form-label">Wards</label>
                                                <select class="select2 form-select" id="ward_id" name="ward_id" >
                                                    <option value="0">--All Wards--</option>
                                                    @foreach($wards as $val)

                                                        @php $selected = '';  @endphp 
                                                        @if($ward_id == $val->id)
                                                        @php $selected ='selected'; @endphp
                                                        @endif
                                                    <option {{ $selected }} value="{{ $val->id }}">{{ $val->ward_name }}</option>
                                                    @endforeach 
                                                </select>
                                            </div>

                                            <div class="col-sm-2">
                                                <label class="form-label">Vehicle</label>
                                                <select name="vehicle_id" id="vehicle_id" class="select2 form-select">
                                                    <option value="0">--All Vehicles--</option>
                                                    @foreach($vehicle as $val)

                                                        @php $selected = '';  @endphp 
                                                        @if($vehicle_id == $val->id)
                                                        @php $selected ='selected'; @endphp
                                                        @endif
                                                    <option {{ $selected }}  value="{{$val->id}}">{{$val->vehicle_number }}</option>
                                                    @endforeach  
                                                </select>
                                            </div>
                                           
                                            <div class="col-sm-2">
                                                <label class="form-label">Vehicle Type</label>
                                                <select name="vehicle_type_id" id="vehicle_type_id" class="select2 form-select">
                                                    <option value="0">--- All Vehicle Types ---</option>
                                                    @foreach($vehicle_type as $val)

                                                        @php $selected = '';  @endphp 
                                                        @if($vehicle_type_id == $val->id)
                                                        @php $selected ='selected'; @endphp
                                                        @endif
                                                    <option {{ $selected }} value="{{$val->id}}">{{$val->type }}</option>
                                                    @endforeach  
                                                </select>
                                            </div>

                                            <div class="col-sm-2">
                                              <label class="form-label">Start Date</label>
                                              <?php  //echo $start_date; ?>
                                              <input id="start_date" name="start_date" class="form-control flatpickr-basic" type="text" value="<?php echo $start_date; ?>" >
                                            </div>

                                            <div class="col-sm-2">
                                              <label class="form-label">End Date</label>
                                              <input id="end_date" name="end_date" class="form-control flatpickr-basic" type="text" value="<?php echo $end_date; ?>" >
                                            </div>

                                            <div class="col-sm-2">
                                                <label class="form-label">&nbsp;</label><br>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row w-100">
                                    <div class="col-sm-6">
                                            <button type="submit" class="btn btn-primary">Search</button>
                                            @if ($search) 
                                                <a title="Clear" href="{{ url('/vehicle_tracking_reports/clear_search/khatprakalpa_visit') }}" type="button" class="btn btn-icon btn-outline-primary"><i data-feather="rotate-ccw" class="me-25"></i></i> Clear </a>
                                            @endif       
                                    </div>
                                    <div class="col-sm-6 float-right">
                                        <div class="d-flex align-items-center justify-content-end">
                                        @if(count($records))                
                                            <a title="Clear" href="{{ url('/vehicle_tracking_reports/khatprakalpa_visit/export_excel') }}"  style="float:right;" type="button" class="btn btn-outline-primary"><i class='fa fa-download' arial-hidden="true"></i> Excel</a>
                                        @endif 
                                            <a href="{{ url('vehicle_tracking_reports') }}" 
                                                    class="btn btn-outline-primary float-right" style="margin: 4px;"><span>Back</span></a>
                                                    
                                        </div>      
                                    </div>
                                </div>  
                            </div>
                        </form>
                        <div class="table-responsive">
                            <table class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th class="text-center">Sr.No</th>
                                        <th class="text-left">Date</th>
                                        <th class="text-left">Vehicle Number</th>
                                        <th class="text-left">Route Name</th>
                                        <th class="text-left">GPS Device Number</th>
                                        <th class="text-center">No Of Visits</th>
                                    </tr>
                                </thead>
                                <tbody class="text-left">

                                <?php 
                                    $total_no_of_visits = 0;
                                    if(!empty($records)){
                                     // echo '<pre>'; print_r($records); die;
                                        $i = 0;
                                       // $i = $records->perPage() * ($records->currentPage() - 1);
                                        foreach($records as $aValue){ 
                                        $i++; 
                                        $total_no_of_visits += $aValue->no_of_visits;	
                                        $date = date('d-m-Y',strtotime($aValue->current_day));	 
                                ?>
                                    <tr>
                                        <td class="text-center"><?php echo $i; ?></td>
                                        <td class="text-left"><?php echo $date; ?></td>
                                        <td class="text-left"><?php echo $aValue->vehicle_name;  ?></td>
                                        <td class="text-left"><?php echo ucWords($aValue->route_name);  ?></td>
                                        <td class="text-left"><?php echo $aValue->device_number; ?></td>
                                        <td class="text-center">
                                           <a href="<?php echo url('vehicle_tracking_reports/vehicle_wise_weight_mngmt'); ?>"><?php echo $aValue->no_of_visits;  ?></a>
                                        </td>
                                    </tr> 
                                    <?php } ?>
                                    <tr>
                                        <th colspan="5" class="text-right">Total</th>
                                        <th class="text-center"><?php echo $total_no_of_visits; ?></th>
                                    </tr>
                                    <?php }else{ ?>

                                    <tr>
                                        <td colspan="8" class="text-center" style="color:red">No Record Found.</td>
                                    </tr>
                                   <?php } ?>
                                </tbody>
                            </table>
                            <div class="card-body">
                                <div class="d-flex justify-content-end">
                                    <!-- pagination code -->
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
            <!-- Bordered table end -->
        </div>
    </section>
@endsection

<script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>

<script>
	function get_wards(){
		var Pakage_id = $('#Pakage_id').val();
        $.ajax({
                type: "post",
                url: "{{ url('/route_master/wards') }} ",
                data:{"_token": "{{ csrf_token() }}","Pakage_id":Pakage_id},
                success: function(response){
                  // alert(response);
                   $('#ward_id').html(response); 
                },
                error: function(){						
                    alert("Error while request..");
                }
        });
		
    }
</script>
