@extends('layout.index')
@section('title', 'Single Vehicle Wise Weight Report')

<!-- Dashboard Ecommerce start -->
@section('content')
    @php
    use Carbon\Carbon;
    @endphp
    <section>
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header w-100">
                            <div class="content-header-left">
                                <div class="row breadcrumbs-top">
                                    <div class="col-sm-12">
                                        <h2 class="content-header-title float-left mb-0">Single Vehicle Wise Weight Report </h2>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- Bordered table end -->
        </div>
     
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <form class="dt_adv_search" action="{{ url('/vehicle_tracking_reports/vehicle_wise_weight_mngmt') }}" method="POST">
                            @csrf
                            <input type="hidden" name="form_type" value="search_frm">
                            <div class="card-header w-100">
                                <div class="row w-100">
                                    <div class="col-sm-12">
                                        <div class="row">
                                            
                                            <div class="col-sm-2">
                                                <label class="form-label">Vehicle</label>
                                                <select name="vehicle_id" id="vehicle_id" class="select2 form-select">
                                                    <option value="">--All Vehicles--</option>
                                                    @foreach($vehicle as $val)

                                                        @php $selected = '';  @endphp 
                                                        @if($vehicle_id == $val->id)
                                                        @php $selected ='selected'; @endphp
                                                        @endif
                                                    <option {{ $selected }}  value="{{$val->id}}">{{$val->vehicle_number }}</option>
                                                    @endforeach  
                                                </select>
                                                <h5><small class="text-danger" id="vehicle_id_err"></small></h5>
                                            </div>
                                            
                                            <div class="col-sm-2">
                                              <label class="form-label">Start Date</label>
                                              <input id="start_date" name="start_date" class="form-control flatpickr-basic" type="text" value="<?php echo $start_date; ?>" >
                                            </div>

                                            <div class="col-sm-2">
                                              <label class="form-label">End Date</label>
                                              <input id="end_date" name="end_date" class="form-control flatpickr-basic" type="text" value="<?php echo $end_date; ?>" >
                                            </div>


                                            <div class="col-sm-2">
                                                <label class="form-label">&nbsp;</label><br>
                                                    <button type="submit" class="btn btn-primary" onClick="return validation()">Search</button>
                                                    @if ($search) 
                                                      <a title="Clear" href="{{ url('/vehicle_tracking_reports/clear_search/vehicle_wise_weight_mngmt') }}" type="button" class="btn btn-icon btn-outline-primary"><i data-feather="rotate-ccw" class="me-25"></i> clear </a>
                                                    @endif
                                            </div>

                                            <div class="col-sm-4">
                                            <label class="form-label">&nbsp;</label><br>
                                               <div class="d-flex align-items-center justify-content-end">
                                              

                                                    @if($vehicle_id)
                                                        <a title="Clear" href="{{ url('/vehicle_tracking_reports/vehicle_wise_weight_mngmt/export_excel') }}"  style="margin : 2px;"
                                                            type="button" class="btn btn-outline-primary">
                                                            <i class='fa fa-download' arial-hidden="true"></i> Excel
                                                        </a>
                                                    @endif

                                                    <a href="{{ url('vehicle_tracking_reports') }}" 
                                                        class="btn btn-outline-primary float-right" style="float:right;"><span>Back</span></a>
                                             </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </form>
                        <div class="table-responsive">
                            <table class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th class="text-center">Sr.No</th>
                                        <th class="text-left">Date</th>
                                        <th class="text-center">Loaded Weight</th>
                                        <th class="text-center">Unloaded Weight</th>
                                        <th class="text-center">Net Weight</th>
                                    </tr>
                                </thead>
                                <tbody class="text-left">
                               
                                <?php 
                                // echo '<pre>'; print_r($vehicleWeightData); die;
                                   if(!empty($vehicleWeightData)){
                                        $i = 0;
                                        $dSpan = 0;
                                        //$i = $vehicleWeightData->perPage() *($vehicleWeightData->currentPage() - 1);
                                        foreach($vehicleWeightData as $reckey => $aRec){ 
                                            $i++;
                                            $dSpan = count($aRec['visits']);
                                ?>
                                    <tr>
                                        <td class="text-center" rowspan="<?Php echo $dSpan ?>"><?php echo $i; ?></td>
                                        <td class="text-left" rowspan="<?Php echo $dSpan ?>"><?php echo date('d-m-Y',strtotime($reckey)); ?></td>
                                      
                                   <?Php 
                                        $visit_count = 0;
                                        foreach($aRec['visits'] as $aVisit){ 
                                            if($visit_count > 0) {
                                    ?>
                                    </tr>
                                    <?Php } ?>
                                        <td class="text-center"><?php  echo $aVisit->loaded_weight; ?></td>
                                        <td class="text-center"><?php  echo $aVisit->unloaded_weight; ?></td>
                                        <td class="text-center"><?php  echo $aVisit->net_weight; ?></td>
                                    <?Php 
                                        $visit_count += 1;
                                    } ?>
					            </tr>
                                <?php } }else{ ?>

                                    <tr>
                                        <td colspan="7" class="text-center" style="color:red;">No Record Found.</td>
                                    </tr>
                                   
                                    <?php } ?>
                                     
                                </tbody>
                            </table>
                            <div class="card-body">
                                <div class="d-flex justify-content-end">
                                    <?php
                                       if(!empty($PakageWeightData)){
                                        // echo $PakageWeightData->links();
                                       }
                                     ?>
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
            <!-- Bordered table end -->
        </div>
    </section>
@endsection

<script type="text/javascript">
	function validation() {
 
      if ($('#vehicle_id').val() == ""){
         $('#vehicle_id').parent().addClass('has-error');
         $('#vehicle_id_err').html('Please Select Vehicle.');
         $('#vehicle_id').focus();
         $('#vehicle_id').change(function () {
         $('#vehicle_id').parent().removeClass('has-error');
         $('#vehicle_id_err').html('');
        });
        return false;
      }
    }  
</script>
